import * as THREE from '../3rdparty/threejs/build/three.module.js';
import { C, C as CIRCUIT } from './circuit.js';
import { Sky } from '../3rdparty/threejs/examples/jsm/objects/Sky.js';
import { GUI } from '../other/lil.js';
import CameraControls from '../other/camera-controls.module.js'
import { Water } from '../3rdparty/threejs/examples/jsm/objects/Water.js';
import { CSS3DRenderer }  from '../3rdparty/threejs/examples/jsm/renderers/CSS3DRenderer.js';


CameraControls.install( { THREE: THREE } );
window.THREE = THREE;

var returnKeyPress = async($e)=> {
    $e.preventDefault();
    if ($e.keyCode === 13) {
        var val = $e.target.value;
        console.log("search for "+val);
        $e.target.value = "";
        CIRCUIT.nakedSearch(val, null);
    }
}

//need to turn this into a class.. to instantiate :(
//as we will be unloading it often.
var ACE = {};
ACE.__bREFRESHNEEDED = false;
ACE._znids = null;
ACE.bDISABLED = true;

ACE.setLastAction=function() {
    ACE.lastAction = Date.now()/1000;
}
ACE.idleFor=function($secs=60) {
    var diff = Date.now()/1000 - ACE.lastAction;
    if (diff > $secs) return true;
    return false;
}
ACE.ifIdleFor=function($secs=60) {
    var diff = Date.now()/1000 - ACE.lastAction;
    if (diff > $secs) return ACE.closeAllRefresh();
    return false;
}
ACE.onNewBlock=async()=>{
    return await ACE.closeAllRefresh();
}
ACE.closeAllRefresh=async()=> {
    if (ACE._showNid!=null) {
        ACE.lastAction = Date.now()/1000;
        C.resetDisplay();
        var NOBJ = ANNE.MEMG.getNeuronByNid(ACE._showNid);
        return await ACE.refocus(NOBJ);
    }
}


ACE.lastAction = ACE.setLastAction();

ACE.resetAfterDelete = function() {
    ANNE.A.setHTML("hsearch_lbl", "find a thing", true);
    var el_search = document.getElementById("anne_hsearch");
    el_search.removeAttribute("disabled");
    ANNE.A.show(el_search);
    ANNE.A.__getEl("anne_hsearch").focus();
    ANNE.A.show("threejs_search_bar");
    ANNE.A.hide("reset_display");
    var tnids = ACE.CIRCUIT.resetDisplay();

    ACE._showTgen = null;
    ACE._showNid = null;
    ACE._showTNObjs = [];

    if (tnids.length>0) {
        var nObj = ANNE.MEMG.getNeuronByTempNid(tnids[0]);
        if (nObj!=null) {
            console.log("we could re-launch this if we want.. hmm.");
        }
    }
}


//when we come back to ACE (in the app)
//these have been upgraded (via the sendQ)
//and we need a refresh
ACE.setRefreshers=function($znids) {
    ANNE.ACE.__bREFRESHNEEDED=true;
    if (ACE._znids==null) {
        ACE._znids = $znids;
        return;
    }

    //add the changed keys to help us track old nids and new nids that have changed.
    //when we refocus the app we'll refresh the display once.
    var keys = Object.keys($znids);
    for (var k=0; k < keys.length; k++) {
        ACE._znids[keys[k]]=$znids[keys[k]];
    }
}

window.ACE = ACE;

ACE._bRUNONCE = false;

ACE.chaseWikispooks = [];
    
ACE.cQ = [];
ACE._showTgen = null;
ACE._showNid = null;
ACE._showTNObjs = [];
ACE._chaseGenTIndex=0;      //used when chasing a gen and iterating through the tgens and looking up their data.


ACE.bAUTOCLOSECONSOLE = false;
ACE._bBLOCKING=false;

ACE._nextValidTick=0;

ACE.container=null;
ACE.stats=null;
ACE.camera=null;
ACE.scene=null;
ACE.renderer=null;
ACE.rendererCSS=null;
ACE.controls=null;
ACE.sun=null;
ACE.water = null;

ACE.el_neuronDisp = null;
ACE.parameters = {
        inclination: 0.5,
        azimuth: 0.205 
    };

ACE.sound=null;
ACE.sound_tense=null;   

//ACE._compareDepth = 3;

ACE.toggleBackgroundSound=function() {
    if (ACE.sound.isPlaying==false) ACE.sound.play();
    else ACE.sound.stop();
}

ACE.appParams = null;

ACE._minZoom = .1;
ACE._maxZoom = 200;
ACE._defCamY = 200;

ACE.ticks = 0;
ACE.hold_tick = 0;
ACE.ky = null;
ACE.pmremGenerator = null;
ACE.hold = -1;
ACE.clock =  null;
ACE.el_console = null;
ACE.el_target_bts = null;

ACE._ambigResolutions = [];
ACE._ambigTempCallback = null;
ACE._activeExternalMod = null;

ACE.animationLoopId = null;


ACE.bINIT_MANUAL = false;

/**
 * 
 */
ACE.initMANUAL = async()=> { 
    if (ACE.bINIT_MANUAL==true) return;
    ACE.clock = new THREE.Clock();

    ACE.el_neuronDisp = document.getElementById("threejs_leftOverlay_dossier");

    //left log click -- zoom to neuron.
    var threejs_leftOverlay = document.getElementById("threejs_leftOverlay");
    threejs_leftOverlay.addEventListener("click", function($e) {
        var cel = ANNE.A.extractNearestObjByProp($e.target, "circ_id");
        
        if (cel!=null && cel!=undefined) {
            var circ_id = cel.getAttribute("circ_id");
            var tnid = cel.getAttribute("tnid");
            var circ = CIRCUIT.getCircById(circ_id);
            if (circ==null) return;
            var tgen = CIRCUIT.getTgen(circ, tnid);
            if (tgen==null) return;

            ANNE.A.hide("btn_wikipedia_redo");
            ANNE.A.hide("btn_wikispooks_redo");
            try {
                if (tgen.gen==0) CIRCUIT.toggleTargetNeuron(tgen);
                else CIRCUIT.toggleSubGen(tgen);
            }
            catch(e) {
                console.log(e);
                ACE.processingDone("ERROR");
            }
            
        }
    })

    ACE.elCSSid = "csscontainer";
    
    var container = document.getElementById( 'container' );
    ACE.renderer = new THREE.WebGLRenderer({antialias:true}); //{ antialias: true, alpha: true }
    ACE.renderer.setPixelRatio( window.devicePixelRatio );
    ACE.renderer.setSize( window.innerWidth, window.innerHeight );
    container.appendChild( ACE.renderer.domElement );
    ACE.scene = new THREE.Scene();
    ACE.renderer.setClearColor(0x000000); 

    var csscontainer = document.getElementById( ACE.elCSSid );
    ACE.rendererCSS = new CSS3DRenderer();

    ACE.renderer.setPixelRatio( window.devicePixelRatio );
    ACE.rendererCSS.setSize( window.innerWidth, window.innerHeight );
    ACE.rendererCSS.domElement.style.position = 'absolute';
    ACE.rendererCSS.domElement.style.top = 0;
    csscontainer.appendChild( ACE.rendererCSS.domElement );

    ACE.renderer.gammaOutput = true;
    ACE.renderer.gammaFactor = 2.2;
    ACE.renderer.toneMapping = THREE.ACESFilmicToneMapping;
	ACE.renderer.toneMappingExposure = 0.8;  //causes darker tone .. darkness..
    
    

    const ambientLight = new THREE.AmbientLight(0x202020, 0.5); // Color, Intensity
    ACE.scene.add(ambientLight);

    //******************** CAMERA *****************/
    ACE.camera = new THREE.PerspectiveCamera(60, window.innerWidth / window.innerHeight, 1, 20800 );
    ACE.camera.position.set(  0, ACE._defCamY, 0 );
    ACE.camera.setFocalLength(60);

    const listener = new THREE.AudioListener();
    ACE.camera.add( listener );

    ACE.controls = new CameraControls( ACE.camera, ACE.rendererCSS.domElement );
    ACE.controls.maxPolarAngle = 1.5088724652651286;
    ACE.controls.minPolarAngle = 0;
    ACE.controls.setTarget( 0, 0, 0 );
    ACE.controls.minDistance = 100;
    ACE.controls.maxDistance = 20800;
    ACE.controls.minZoom = ACE._minZoom;
    ACE.controls.maxZoom = ACE._maxZoom;
    ACE.controls.zoomTo(1, false);
    ACE.controls.mouseButtons.wheel = CameraControls.ACTION.ZOOM;
    ACE.controls.mouseButtons.right = CameraControls.ACTION.TRUCK;
    
    // create a global audio source
    ACE.sound = new THREE.Audio( listener );
    ACE.sound_tense = new THREE.Audio( listener );

    ACE.yellowLineMat = new THREE.LineBasicMaterial({
        color: "yellow",
        linewidth: 3
    });

    // load a sound and set it as the Audio object's buffer
    const audioLoader = new THREE.AudioLoader();
    audioLoader.load('./mp3/ambient_waves.mp3', function( buffer ) {
        ACE.sound.setBuffer( buffer );
        ACE.sound.setLoop( true );
        ACE.sound.setVolume(.5);
    });

    audioLoader.load('./mp3/tense_background.mp3', function( buffer ) {
        ACE.sound_tense.setBuffer( buffer );
        ACE.sound_tense.setLoop( true );
        ACE.sound_tense.setVolume(.5);
    });

 
    //sun
    ACE.sun = new THREE.Vector3();


    //TODO:
    //should have a toggle to turn off water for lower-lvl system that are having issues
    //with resources.

    //******************** water *****************/
    var waterGeometry = new THREE.PlaneGeometry( 1000000, 1000000 );
    ACE.water = new Water(
        waterGeometry,
        {
            textureWidth: 1024,
            textureHeight: 1024,
            waterNormals: new THREE.TextureLoader().load( './js/other/textures/waternormals.jpg', function ( texture ) {
                texture.wrapS = texture.wrapT = THREE.RepeatWrapping;

            } ),
            alpha: 1.0,
            sunDirection: new THREE.Vector3(),
            sunColor: 0xffffff,
            waterColor: 0x001e0f,
            distortionScale: 3.7,
            fog: ACE.scene.fog !== undefined
        }
    );

    ACE.water.rotation.x = - Math.PI / 2;
    ACE.scene.add( ACE.water );
    
    /*********** SKY ************/
    ACE.sky = new Sky();
    ACE.sky.scale.setScalar( 100000 );
    ACE.scene.add( ACE.sky );
    var uniforms = ACE.sky.material.uniforms;
    uniforms[ 'turbidity' ].value = 0;
    uniforms[ 'rayleigh' ].value = 0.01;
    uniforms[ 'mieCoefficient' ].value = 0.54;
    uniforms[ 'mieDirectionalG' ].value = 6.17;

    ACE.pmremGenerator = new THREE.PMREMGenerator( ACE.renderer );
        
    ACE.updateSun();

    ANNE.gsap = gsap;   //set the ANNE ptr for this gsap for use in our A mod.

    ACE.gui = new GUI({ autoPlace: false, autosave:false}, function() {
        console.log("dat gui closed");
    });
    GUI.TEXT_CLOSED = 'Close Settings';
    GUI.TEXT_OPEN = 'Open Settings';

    var elDatGui = ANNE.A.__getEl('dat_gui_container2');
    if (elDatGui!=null) {
        elDatGui.appendChild(ACE.gui.domElement);
        elDatGui.addEventListener('mouseleave', ($e)=>{
            //if menu is already closed, do nothing on mouse leave.
            const mainDiv = elDatGui.querySelector('.main');
            if (mainDiv==null) return;
            const ulClosed = mainDiv.children[0];
            if (mainDiv && ulClosed.classList.contains("closed")==true) return;
            const clickEvent = new MouseEvent('click', {
                view: window,
                bubbles: true,
                cancelable: true
              });
            ACE.gui.__closeButton.dispatchEvent(clickEvent);
        });
    }

    var hpOptions = {
        annet: false,
        anneid: false,
        andy: false,
        lnot: false
    };

    //load in default.
    var homepage = ANNE.SETTINGS.getPref("homepage");
    if (homepage!=null) {
        if (homepage.misc_value=="annet") hpOptions.annet=true;
        else if (homepage.misc_value=="anneid") hpOptions.anneid=true;
        else if (homepage.misc_value=="andy") hpOptions.andy=true;
        else if (homepage.misc_value=="lnot") hpOptions.lnot=true;
    }

    var setChecked=function( prop ){
        for (let param in hpOptions){
          hpOptions[param] = false;
      }
      hpOptions[prop] = true;
    }

    var folder = ACE.gui.addFolder('APP settings');
    var features = folder.addFolder("features", "dg-d2");

    //untested.
    features.add(ANNE.SETTINGS, 'bDATAMESSAGES').name('Live Msgs').onChange(
        function(){
            console.log("data_messages");
            if (ANNE.SETTINGS.bDATAMESSAGES==false) {
                if (ANNE.NET!=null) ANNE.NET.stopInterval();
            }
            else {
                if (ANNE.NET!=null) ANNE.NET.restartInterval();
            }
            ANNE.SETTINGS.setPref("data_messages", ANNE.SETTINGS.bDATAMESSAGES+"", "");
        }
    );
    features.add(ANNE.SETTINGS, '_maxMsgBlockGap').name('max msg block gap').onChange(
        function(){
            ANNE.SETTINGS.setPref("_maxMsgBlockGap", ANNE.SETTINGS._maxMsgBlockGap+"", "");
        }
    );
    features.add(ANNE.SETTINGS, 'bPRELOADALLDATA').name('pull data new data at bootup').onChange(
        function(){
            ANNE.SETTINGS.setPref("bPRELOADALLDATA", ANNE.SETTINGS.bPRELOADALLDATA+"", "");
        }
    );
    features.add(ANNE.SETTINGS, 'bMAXIMIZE_JS_MEM').name('maximize js mem').onChange(
        function(){
            ANNE.SETTINGS.setPref("bMAXIMIZE_JS_MEM", ANNE.SETTINGS.bMAXIMIZE_JS_MEM+"", "");
        }
    );
    features.add(ANNE.SETTINGS, 'bANTORIMGSONLY').name('antor imgs only').onChange(
        function(){
            ANNE.SETTINGS.setPref("bANTORIMGSONLY", ANNE.SETTINGS.bANTORIMGSONLY+"", "");
        }
    );
    
    /*
    features.add(ANNE.SETTINGS, 'bUICOS').name('neuron emojis').onChange(
        function(){
            ANNE.SETTINGS.setPref("bUICOS", ANNE.SETTINGS.bUICOS+"", "");

            if (ANNE.SETTINGS.bUICOS==false) {
                for (var n=0; n < ANNE.MEM._aNeurons.length; n++) {
                    if (ANNE.MEM._aNeurons[n]._uico) {
                        ANNE.MEM._aNeurons[n]._uico = "";
                    }
                }
            }
        }
    );
    */

    ANNE.SETTINGS.loadMsgPrefGUI(folder);

    var folderHomePage = folder.addFolder("homepage", "dg-d2");
    folderHomePage.add(hpOptions, 'annet').name('Hypergraph Explorer').onChange(
        function(){
            console.log("annet");
            setChecked('annet');
            ANNE.SETTINGS.setPref("homepage", "annet", "");
        }
    );
    folderHomePage.add(hpOptions, 'anneid').name('Wallet').onChange(
        function(){
            console.log("anneid");
            setChecked('anneid');
            ANNE.SETTINGS.setPref("homepage", "anneid", "");
        }
    );
    folderHomePage.add(hpOptions, 'andy').name('Andy Admin').onChange(
        function(){
            console.log("andy");
            setChecked('andy');
            ANNE.SETTINGS.setPref("homepage", "andy", "");
        }
    );
    folderHomePage.add(hpOptions, 'lnot').name('Local Notification').onChange(
        function(){
            console.log("lnot");
            setChecked('lnot');
            ANNE.SETTINGS.setPref("homepage", "lnots", "");
            
        }
    );

    //ANNET folder.
    var explorerFolder = ACE.gui.addFolder("ANNET Explorer settings", "dg-d1");
    explorerFolder.add(ANNE.SETTINGS, "bDOWIKIPEDIA", ANNE.SETTINGS.bDOWIKIPEDIA).name("do wikipedia").onChange(
        function(value) {
            console.log(value);
            console.log(this);
            var val = "blah";
            var prop = "bDOWIKIPEDIA";
            if (value==true) val = "true";
            else val = "false";
            ANNE.SETTINGS.setPref(prop, val, "");
            ACE.assessWIKIPEDIA();
        }
    );

    explorerFolder.add(ANNE.SETTINGS, "bDOWIKISPOOKS", ANNE.SETTINGS.bDOWIKISPOOKS).name("do wikispooks").onChange(
        function(value) {
            console.log(value);
            console.log(this);
            var val = "blah";
            var prop = "bDOWIKISPOOKS";
            if (value==true) val = "true";
            else val = "false";
            ANNE.SETTINGS.setPref(prop, val, "");
            ACE.assessWIKISPOOKS();
        }
    );

    explorerFolder.add(ANNE.SETTINGS, "bDOTMDB", ANNE.SETTINGS.bDOTMDB).name("do TMDB").onChange(
        function(value) {
            console.log(value);
            console.log(this);
            var val = "blah";
            var prop = "bDOTMDB";
            if (value==true) val = "true";
            else val = "false";
            ANNE.SETTINGS.setPref(prop, val, "");
            ACE.assessWIKISPOOKS();
        }
    );

    explorerFolder.add(ANNE.SETTINGS, "bDOWIKIDATA", ANNE.SETTINGS.bDOWIKIDATA).name("do wikidata").onChange(
        function(value) {
            console.log(value);
            console.log(this);
            var val = "blah";
            var prop = "bDOWIKIDATA";
            if (value==true) val = "true";
            else val = "false";
            ANNE.SETTINGS.setPref(prop, val, "");
            ACE.assessWIKISPOOKS();
        }
    );

    explorerFolder.add(ANNE.SETTINGS, 'bAUTOHANAI', false).name("auto hanai");
    explorerFolder.add(ACE, 'bAUTOCLOSECONSOLE', true).name("auto close console");
    
    ACE.appParams = {
        toggleSound:ACE.toggleBackgroundSound
    }

    ACE.bTMDB_ACTIVE = false;
    if (ANNE.SETTINGS._tmdb_key.length) ACE.bTMDB_ACTIVE = true;
    
    // create a checkbox
    ACE.TMDBfolder = explorerFolder.addFolder ('TMBD', "dg-d2");
    var chk_tmdb = ACE.TMDBfolder.add({ showInput: false }, 'showInput').name('enter tmdb key');
    
    // add event listener to checkbox
    chk_tmdb.onChange(function($value) {
        if (chk_tmdb.__checkbox.value=="on") {
            // create input box
            ACE.appParams.tmdb_input = ACE.TMDBfolder.add({ code:ANNE.SETTINGS._tmdb_key }, 'code').name('tmdb key');
            var el_input = ACE.appParams.tmdb_input.domElement.querySelector('input');
            el_input.setAttribute('placeholder', 'Enter tmdb key');

            // inject sav button
            ACE.appParams.tmdb_btn_save = ACE.TMDBfolder.add({ save:async()=> {
                    var newkey = ACE.appParams.tmdb_input.object.code;
                    if (newkey.length) {
                        ACE.bTMDB_ACTIVE=true;
                    }
                    else {
                        ACE.bTMDB_ACTIVE=false;
                    }

                    await ANNE.SETTINGS.setPref("tmdb_key", newkey, "tmdb_key");
                    
                    ACE.assessTMDB();

                    ANNE.A.hide(ACE.appParams.tmdb_btn_save.__button);
                    
                }}, 'save').name('SAVE KEY');


            el_input.addEventListener("input", ()=>{
                if (el_input.value.length) ANNE.A.show(ACE.appParams.tmdb_btn_save.__button);
                else ANNE.A.hide(ACE.appParams.tmdb_btn_save.__button);
            });

        } 

        // remove input box and save button
        else {
            if (ACE.appParams.tmdb_input!=undefined) ACE.TMDBfolder.remove(ACE.appParams.tmdb_input);
            if (ACE.appParams.tmdb_btn_save!=undefined) ACE.TMDBfolder.remove(ACE.appParams.tmdb_btn_save);
        }
    });

    
    var foldersky = explorerFolder.addFolder('Sky', "dg-d2");
    foldersky.add( ACE.parameters, 'inclination', 0, 0.5, 0.0001 ).onChange( ACE.updateSun );
    foldersky.add( ACE.parameters, 'azimuth', 0, 1, 0.0001 ).onChange( ACE.updateSun );
    
    var folderSun = explorerFolder.addFolder('Sun', "dg-d2");
    
    var uniformsSun = ACE.sky.material.uniforms;
    folderSun.add( uniformsSun.turbidity, 'value', 0, 40, .1 ).name( 'turb' ).onChange( ACE.updateSun );
    folderSun.add( uniformsSun.rayleigh, 'value', 0, 1, 0.01).name( 'rayleigh' ).onChange( ACE.updateSun );
    folderSun.add( uniformsSun.mieCoefficient, 'value', 0, 1, 0.005).name( 'minCof' ).onChange( ACE.updateSun );
    folderSun.add( uniformsSun.mieDirectionalG, 'value', 0, 10, .01).name( 'dirG' ).onChange( ACE.updateSun );
    var folderWater = explorerFolder.addFolder('Water', "dg-d2");
    
    var uniformsWater = ACE.water.material.uniforms;
    folderWater.add(uniformsWater.distortionScale, 'value', 0, 8, .5 ).name( 'distortionScale' );
    folderWater.add(uniformsWater.size, 'value', 0.1, 9.9, 0.1 ).name( 'size' ).setValue(9.9);
    folderWater.add(uniformsWater.alpha, 'value', 0.1, 1, .01 ).name( 'alpha' ).setValue(1);

    var ta = new threeanne(THREE, gsap, ACE.gui, ACE.scene, ACE.controls);
    ta.ACE = ACE;   //just pop it all in there (lolz)

    //Only these neurons are chaseable in this circuit app.
    //This helps us focus on the things that tie "people" together..
    //which is the purpose of this app.
    var chaseableClassTnids = [MEM.location.temp_nid, MEM.ec_action.temp_nid, 
                                MEM.person.temp_nid, MEM.company.temp_nid, 
                                MEM.identity.temp_nid, MEM.site.temp_nid, 
                                MEM.geo_site.temp_nid, MEM.gregorian_date.temp_nid,
                                MEM.group_event.temp_nid, MEM.power_family.temp_nid, MEM.group.temp_nid];

    
    ACE.chaseWikispooks=[MEM.group.temp_nid, MEM.group_event.temp_nid, MEM.person.temp_nid, MEM.company.temp_nid, MEM.location.temp_nid];
    ACE.chaseWikidata=[MEM.group.temp_nid, MEM.group_event.temp_nid, MEM.person.temp_nid, MEM.company.temp_nid, MEM.location.temp_nid];

    //for now, only this one.
    ACE.chaseTMDB=[MEM.person.temp_nid];



    CIRCUIT.init(ta, 1200, 60, chaseableClassTnids);

    ACE.CIRCUIT = CIRCUIT; 
    ANNE.CIRCUIT = CIRCUIT; 

    ACE.gui.close();
    //allow user to turn on/off water and swap it out with a grid.

    //const pointLight = new THREE.PointLight(0xffffff, 10, 10000);
    //pointLight.position.set(0, 5000, 0);
    //ACE.scene.add(pointLight);

    ACE.runOnce();

    var el_mergedd = document.getElementById("merge_with_neuron");
    el_mergedd.addEventListener("change", e=>ACE.mergeNeurons(e))
    ACE.animate();

    ACE.bINIT_MANUAL=true;
}



/**
 */
ACE.refocus=async($defaultTopNObj=null, $preloadText="")=>{
    var tjssb = ANNE.A.show("threejs_search_bar");
    tjssb.style.pointerEvents="all";
    var cssel = ANNE.A.show("csscontainer");
    cssel.style.pointerEvents="all";
    var tjsel = ANNE.A.show("container");
    tjsel.style.pointerEvents="all";


    ANNE.MEM_UDF._bSHOWINGTHREEJS = true;

    if (ACE.__bREFRESHNEEDED==true) {
        ACE.__bREFRESHNEEDED = false;
        await ACE.CIRCUIT.refreshAllCircuits(ACE._znids);
        ACE._znids = null;
    }

    ANNE.A.show("btns_footer");
    ANNE.A.hide("anne_site");

    //could do this w/ css class but i don't want to chng it right now.  optimize later.  
    ANNE.MEM_UDF.assessGhostSaveToANNE();

    if (ACE._bRUNONCE==false) {
        await ANNE.ACE.initMANUAL();
    }
    
    ANNE.ACE.enable(); //if already enabled (in any given cycle) nothing is done here.


    if ($defaultTopNObj!=null) {
        ANNE.A.hide("anne_hsearch");
        return ACE.CIRCUIT.manualLaunchTop($defaultTopNObj);
    }

    if (ACE.CIRCUIT.hasCircuit()==true) {
        ANNE.A.hide("anne_hsearch");
    }

    //experimental preload use of the text search here.
    if ($preloadText!="") {
        anne_hsearch.value = $preloadText;
        await CIRCUIT.nakedSearch($preloadText, null);
    }
    
}


ACE.runOnce = function() {
    //sound prefs have changed.
    document.addEventListener(ANNE.EVENT_SOUND_CHANGE, function(e){
        if (ANNE.SETTINGS.soundOk()==false) {
            if (ACE.sound.isPlaying==true) {
                ACE.sound.stop();
            }
            if (ACE.sound_tense.isPlaying==true) {
                ACE.sound_tense.stop();
            }
        }
    });


    var exit_explorer_el  = document.getElementById("close_explorer");
    exit_explorer_el.addEventListener("click", ($e)=>{
        console.log("EXIT EXPLORER");
        ANNE.MEM_UDF.hide3js();
        ANNE.MEM_UDF.goToPrev();
    });

    var exit2 = document.getElementById("exit_explorer");
    exit2.addEventListener("click", ($e)=>{
        console.log("EXIT EXPLORER2");
        ANNE.MEM_UDF.hide3js();
        ANNE.MEM_UDF.goToPrev();
    });

    var search_input = document.getElementById("anne_hsearch");
    search_input.focus();
    ACE.el_bebox_img = document.getElementById("lo_img");
    ACE.el_btn_up = document.getElementById("btn_up");
    ACE.el_btn_up.addEventListener("click", function($){
        if (ACE._showTNObjs.length>1) {
            ACE.goToLastTNObj();
        }
        else {
            console.log("no back to go to");
            ANNE.A.hide(ACE.el_btn_up);
        }
    })

    //anytime we close the circuit_console set blocking to false
    ACE.el_console = document.getElementById("console_print");
    var console_close = document.getElementById("console_close");
    console_close.addEventListener("click", function($e){
        $e.stopPropagation();
        $e.preventDefault();
        ACE.closeConsole();
    })

    ACE.processingStart("Build, explore and compare the neural-circuits for known persons or companies.", false, true);
    ACE.addToConsole("Search for neurons above in the search field and add them to the screen to continue.");
    ACE.addToConsole("Close this window to continue.");


    var el_redo_wikipedia = document.getElementById("btn_wikipedia_redo");
    el_redo_wikipedia.addEventListener("click",  ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        if(ANNE.isANNE(ANNE.USER._userNObj.nid)==true) {
            ANNE.A.hide(el_redo_wikipedia);
            ACE.CIRCUIT.forceChaseWIKIPEDIA(ACE._showTgen);
        }
        else alert("coming soon");
    });
    el_redo_wikipedia.classList="disabled";


    var el_redo_wikispooks = document.getElementById("btn_wikispooks_redo");
    el_redo_wikispooks.addEventListener("click", ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        ANNE.A.hide(el_redo_wikispooks);
        ACE.CIRCUIT.forceChaseWIKISPOOKS(ACE._showTgen);
    });

    var el_do_tmdb = document.getElementById("btn_tmdb_redo");
    el_do_tmdb.addEventListener("click", ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        ANNE.A.hide(el_do_tmdb);
        ACE.CIRCUIT.forceChaseTMDB(ACE._showTgen);
    });


    var el_chase_one_gen = document.getElementById("btn_chase_view");
    el_chase_one_gen.addEventListener("click", ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        ANNE.A.hide(el_chase_one_gen);
        ACE.chaseOneGen( ACE._showTgen);
    });


    var el_upgrade_data = document.getElementById("btn_upgrade_data");
    el_upgrade_data.addEventListener("click", ($e)=>{
        ANNE.A.hide(el_upgrade_data);
        $e.stopPropagation();
        $e.preventDefault();
        ACE.upgradeNeuronGhostsOrHanais();
    });


    var el_dossier = document.getElementById("btn_dossier_view");
    el_dossier.addEventListener("click", ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        ANNE.A.hide("csscontainer");
        ANNE.A.hide("container");
        PAGES.launchNeuron(ACE._showNid, "dossier", $e);
    });


    //just exploring ways to do clean gui injection edits.. hmmm
    //try this on company type
    var el_edit_btns_on = document.getElementById("btn_editable_relons_toggle");


    el_edit_btns_on.addEventListener("click", ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        ANNE.A.hide(el_edit_btns_on);

        //these will operate from param-txids and generate auto from there.
        var els_add = document.querySelectorAll(".gui-add-new");
        for (var e=0; e < els_add.length; e++) {
            var _el = els_add[e];
            var param_txid = _el.getAttribute("param-txid");
            if (param_txid==undefined || param_txid==null) continue;
            //TO DO -->  (alias is a good one to start with)
        }
        
        //any gui sif we've added we want to show.
        var els = document.querySelectorAll(".ANNE-SIF");
        for (var e=0; e < els.length; e++) {
            var _el = els[e];
            ANNE.A.show(_el);
        }
        

        //editables.
        var els = document.querySelectorAll(".gui-editable");
        for (var e=0; e < els.length; e++) {
            var _el = els[e];
 
            var edit_restrict_class = _el.getAttribute("edit-restrict-class");
            if (edit_restrict_class==undefined || edit_restrict_class==null) {  
                continue;
            }

            var edit_txid = _el.getAttribute("edit-txid");
            var edit_rel = null;

            if (edit_txid!=undefined && edit_txid!=null) {
                edit_rel = ANNE.MEMG.lookupByTXID(edit_txid);
            }

            var page = _el.getAttribute("page");
            if (page==undefined || page==null) {
                //do an auto page lookup here based on txid.
            }

            //a bit crazy, but let's give it a go.
            //<button class="anne-btn2 ico-img-small bg-edit-ico" title="quick edit neuron name"></button>
            ANNE.A.ezButton(_el, "", "", "anne-btn2 ico-img-small bg-edit-ico", async($e)=>{
                $e.stopPropagation();
                $e.preventDefault();
                
                ACE.openConsole();

                //force interaction with the injected form.
                ANNE.A.hide("console_close");

                var pObj = new page_params(
                    async($relnNOBJ, $toNOBJ, $ge)=> {
                        ANNE.playSound("success");
                        await PAGES.closeInjectedDetails($ge);
                        ACE.closeConsole();
                    }, 
                    
                    async($ge)=> {
                        await PAGES.closeInjectedDetails($ge);
                        ACE.closeConsole();

                    }, null, ACE._showNid);

                var valueNOBJ = ANNE.MEMG.getNeuronByNid(edit_restrict_class);
                pObj.injection_div = ACE.el_console.id;
                pObj.misc = {default_val:edit_rel.to_s, 
                            classRestrictNid:edit_restrict_class,
                            existing_rel:edit_rel,
                            gui_el:_el};
                pObj.misc.bNEWVALUESOK = false;
                pObj.misc.from_nid = edit_rel.from_nid;
                pObj.misc.reln_nid = edit_rel.reln;
                pObj.misc.disambig_text_only = true;
                pObj.misc.prompt = "edit the existing "+valueNOBJ.text+" value";
                pObj.misc.ghostBtnText = "accept edit";
                
                pObj.misc.action_override = async($pObj, $selected_val)=>{
                    console.log("action override ", $pObj, $selected_val);
                    
                    var old_value = pObj.misc.existing_rel.to_s.concat();
                    
                    //we want to edit the pObj.misc.existing_rel in GHOST MEMORY.
                    await GHOSTDATA.updateRelonTo(pObj.misc.existing_rel, $selected_val);
                
                    //we want to fix the display of gui_el.
                    if (pObj.misc.existing_rel.to_type==TO_TYPE_ANNE) {
                        var toNOBJ = ANNE.MEMG.getNeuronByNid($selected_val);
                        ANNE.A.setHTML(pObj.misc.gui_el, toNOBJ.text);

                        //we want to fix the display of the neuron lbl of the neuron in the circuit.
                        ACE.CIRCUIT.updateSingleTO( ACE._showTgen, ACE._showNid, old_value, pObj.misc.existing_rel.txid);
                    }
                    else {
                        ANNE.A.setHTML(pObj.misc.gui_el, $selected_val);
                    }

                    //close the console.
                    ACE.closeConsole();
                }

                await PAGES.openPart(page, pObj);
            })
        }
    });

    var el_delete_circuit = document.getElementById("btn_delete_circuit");
    el_delete_circuit.addEventListener("click", ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        ACE.deleteCircuit();
    });

    var search_input = document.getElementById("anne_hsearch");
    search_input.addEventListener("keyup", e=>returnKeyPress(e));
    search_input.focus();

    //reset link on left thingy
    var reset_display = document.getElementById("reset_display");
    reset_display.addEventListener("click", function($e){
        console.log("reset_display");
        $e.stopPropagation();
        $e.preventDefault();
        ANNE.A.hide("threejs_leftOverlay");
        ANNE.A.hide("reset_display");
        ANNE.A.show("threejs_search_bar");
        ANNE.A.setHTML("hsearch_lbl", "find a thing", true);
        var el_search = document.getElementById("anne_hsearch");
        el_search.removeAttribute("disabled");
        ANNE.A.show(el_search);
        ANNE.A.__getEl("anne_hsearch").focus();
    
        ACE.CIRCUIT.resetDisplay();
        
        ACE._showTgen = null;
        ACE._showNid = null;
        ACE._showTNObjs = [];
    });


    //this will only launch the main circuits (not their nested lines)
    var refresh_this = document.getElementById("refresh_this");
    if (refresh_this!=null) {
        refresh_this.addEventListener("click", async($e)=>{
            $e.stopPropagation();
            $e.preventDefault();
            ANNE.A.setHTML("hsearch_lbl", "find a thing", true);
            var el_search = document.getElementById("anne_hsearch");
            el_search.removeAttribute("disabled");
            ANNE.A.show(el_search);
            ANNE.A.__getEl("anne_hsearch").focus();
            ANNE.A.show("threejs_search_bar");
            ANNE.A.hide("refresh_this");
            var root_tnids = ACE.CIRCUIT.resetDisplay();
            
            for(var c=0; c <root_tnids.length; c++) {
                var rootNOBj = ANNE.MEMG.getNeuronByTempNid(root_tnids[c]);
                await ANCE.CIRCUIT.manualLaunchTop(rootNOBJ);
            }
        });
    }

    /************ ONE-TIME EVENT SETTING *************/
    ACE._bRUNONCE=true;
}


/**
 */
ACE.testToShowDelete=function(){
    ANNE.A.hide("btn_delete_circuit");

    if (ACE._showNid==null) {
        console.log("no active show nid");
        return;
    }

    var selectedNOBJ = ANNE.MEMG.getNeuronByNid(ACE._showNid);
    if (selectedNOBJ==null) {
        console.log("no active neuron");
        return;
    }

    if (selectedNOBJ.ghost==false) {

        //owner can delete neuron circuit. 
        //show we prevent ANNE NEURONS from being deleted ?
        //in fairness to the gen pub, should even an ANNE-owned neuron be deletable?
        //Mergable, yes, but deletable?
        //It is possible ANNE admins approve bad neurons and they need to just simly get nuked..
        //hmm.  controls?  Audits?  Safety checks in L1 to prevent data from being wiped out?
        if (selectedNOBJ.owned_by!=USER._userNObj.nid) return;
    }

    if (selectedNOBJ.bes[0]==MEM.comp_union.temp_nid) return;

    //this can be deletable.
    ANNE.A.show("btn_delete_circuit");

    //note, we can also delete real things too (requesting to arbor prune etc...)
    //will do this later.
}



/**
 * To Do:
 * write this to easily allow for ghost deletes of circuits
 */
ACE.deleteCircuit = async()=>{
    if (ACE._showNid==null) {
        console.log("no active show nid");
        return;
    }

    var selectedNOBJ = ANNE.MEMG.getNeuronByNid(ACE._showNid);
    if (selectedNOBJ==null) {
        console.log("no active neuron");
        return;
    }

    if (selectedNOBJ.ghost==false) {
        if (selectedNOBJ.owned_by!=USER._userNObj.nid) return;
    }

    ANNE.A.hide("btn_delete_circuit");

    //do the nuke.
    console.log(ACE._showTgen);
    var nid = selectedNOBJ.nid;
    
    await ACE.hideOnly();

    await GHOSTDATA._annihilateGhostNeuron(selectedNOBJ);

    //this should remove the NID we deleted (from top circ or from any inclusion in lower levels)
    //this will regen the entire graph
    await ACE.CIRCUIT.refreshAllCircuits({}, nid);
}



/**
 * We want to chase for new anne and external data for any given tgen.
 * NOTE: this can take a very long time if there are thousands of items in a neuron!
 * (like WEF groups, eppy black book etc)
 */
ACE.chaseOneGen = async($tgen)=>{
    var name = $tgen.getName();
    console.log("chaseOneGen) "+name);
    ACE._chaseGenTIndex=0;
    ACE.addToConsole("chasing <b>"+name+"</b> one generation.");

    //chase anne first.
    //build list of non-ghosts that are anne_chaseable.
    var chase_nids = [];
    for(var t=0; t < $tgen.tgens.length; t++) {
        var nObj = ANNE.MEMG.getNeuronByTempNid($tgen.tgens[t].tnid);
        if (nObj.ghost==true) continue;
        if ($tgen.tgens[t].anne_chaseable==false) continue;
        chase_nids.push(nObj.nid);
    }

    //this will get all the ANNE info on all the children tgens in this tgen.
    if (chase_nids.length) await ANNE.CHASE.queryForOutsFroms_not(chase_nids, false);

    ACE.chaseOneGenExternalInner($tgen);
}


/**
 * Here we want to chase the external_chaseable tgens.
 * We can create/open the non chaseables so we have their tgen children made.
 * For those that are external chaseable, we will only chase the external sources according
 * to what parameters are set in the external data menu of the app.
 */
ACE.chaseOneGenExternalInner=async($tgen)=> {
    ACE.addToConsole("chasing "+(ACE._chaseGenTIndex+1)+" of "+$tgen.tgens.length);
    
    if (ACE._chaseGenTIndex>=$tgen.tgens.length) {
        ACE.processingDone();
        return;
    }

    var tgen = $tgen.tgens[ACE._chaseGenTIndex++];
    var nObj = ANNE.MEMG.getNeuronByTempNid(tgen.tnid);

    if (tgen.external_chaseable==true) {
        var nObj = ANNE.MEMG.getNeuronByTempNid(tgen.tnid);
        ACE.addToConsole("chasing <b>"+nObj.text+"</b> one generation.");
    
        ACE.CIRCUIT.chaseExternalData(tgen, nObj, "", async()=>{
            
            //extend the circuit one gen beyond this one. 
            //this gives the setHalos something to make halos with.  :)
            await tgen.buildCircuitLineOneMoreGen(C, tgen.circ);

            //start animation of halos
            ACE.CIRCUIT.setHalos(tgen, function(){
                tgen.bCHASED=true;
                ACE.chaseOneGenExternalInner($tgen);
            });
        });
    }

    //not external chaseable, but still a viable compare circuit with
    //potential relevant connections.
    else {
        ACE.addToConsole("NOT CHASEABLE <b>"+nObj.text+"</b>, skipping.");
        if (ACE._chaseGenTIndex>=$tgen.tgens.length) {
            ACE.processingDone("done chasing");
            return;
        }

        //build the circuit still (even with no external chase)
        await tgen.buildCircuitLineOneMoreGen(C, tgen.circ, nObj, false); //we already chased data.

        //open the circuit
        ACE.CIRCUIT.setHalos(tgen, function(){
            tgen.bCHASED=true;
            ACE.chaseOneGenExternalInner($tgen);
        });
    }
}


/**
 * 
 * @param {*} $e 
 * @returns 
 */
ACE.upgradeNeuronGhostsOrHanais = async()=>{
    if (ACE._showNid==null) {
        console.log("no active show nid");
        return;
    }

    var selectedNOBJ = ANNE.MEMG.getNeuronByNid(ACE._showNid);
    if (selectedNOBJ==null) {
        console.log("no active neuron");
        return;
    }
    ANNE.A.hide("btn_upgrade_data");
    ACE.processingStart("processing ghosts", true, true);

    var ghost_to_anneOBJ = new ghost_to_anne(selectedNOBJ);
    var bSKIPGLOBALS = false;
    var bAUTOHANAI = true;
    if (ANNE.SETTINGS!=null) bAUTOHANAI = ANNE.SETTINGS.bAUTOHANAI;
    await ghost_to_anneOBJ.update(selectedNOBJ, 0, bSKIPGLOBALS, bAUTOHANAI);
    console.log(ghost_to_anneOBJ);

    if (ANNE.SENDQ.aQ.length) {
       await ANNE.SENDQ.___sendQueue(async ($msg="ghosts processed")=>{
            await ACE.refocus();
            ACE.addToConsole($msg);
            ACE.processingDone();
        },null,async()=>{
            ACE.__bREFRESHNEEDED=false;
            await ACE.refocus();
            ACE.addToConsole("send was canceled");
            ACE.processingDone();
        });     
    }
    else {
        ACE.addToConsole("no ghost relons to process");
        ACE.processingDone();
    }
}



/*******  processing/console stuff */
ACE.processingStart = function($msg="", $bHIDECLOSE=true, $bCLOSELEFT=false) {
    if ($bCLOSELEFT==true) {
        console.log("fix this nonsense");
    }
    
    ACE.openConsole();

    //close button.  When loading data we hide the close button.
    //when using it as an intro message, we show the close button.
    //user can close with no negative effects.
    if ($bHIDECLOSE==true) {
        //ANNE.A.hide("console_close");
    }
  
    if ($msg!="") ACE.addToConsole($msg);
    ACE._bBLOCKING=true;
    if (ANNE.SETTINGS.soundOk()==true &&  ACE.sound!=null && ACE.sound.isPlaying==false) {
        ACE.sound.play();
        //ACE.sound_tense.stop();
    }
}


ACE.processingDone = function($bPLAYSOUND=true) {
    ANNE.A.show("console_close");
    if (ACE.bAUTOCLOSECONSOLE==true) ACE.closeConsole();
    else ACE.addToConsole("processing complete");
    $bPLAYSOUND=true; 
    ACE._bBLOCKING=false;
}


ACE.eraseConsole=function() {
    ACE._nextValidTick = 0;
    ANNE.A.empty("console_print");
}


/**
 * We want to let the user decide which neuron it is.
 * We will set the jsonObj.to_s with their selection.
 */
ACE.resolveAmbigs=async($ambigResolutions=null, $callbackDone=null, $EXTERNALMOD=null)=> {
    if ($ambigResolutions!=null) {
        ACE._ambigResolutions = $ambigResolutions;
    }
    if ($callbackDone!=null) {
        ACE._ambigTempCallback = $callbackDone;
    }
    if ($EXTERNALMOD!=null) ACE._activeExternalMod = $EXTERNALMOD;
    //done with ambig resolutions... do callback and reset it.
    //ths will call the external (wikipedia wikispooks) _processing_complete_callback handler
    //to finish off the processing of the data.
    if (ACE._ambigResolutions.length==0) {
        if (ACE._ambigTempCallback !=undefined) {
            ACE._ambigTempCallback(ACE._activeExternalMod);
            ACE._ambigTempCallback = null;
        }
        return;
    }

    // var ambig = {jsonobj:$jsonobj, matches:$matches, lookupval:$lookupval};
    var ambig = ACE._ambigResolutions.shift();
    await ANNE.A.disambigInner(ambig.matches, ambig.lookupval, ambig, ACE.el_console, ACE.resolveAmbigs);
}




/**
 * The user needs to choose which one when 
 * searching and getting multiple potential results back from ANNE
 * @param {*} $aMatches 
 */
ACE.disambigNakedChoice=async($neurons, $val)=> {
    var el_dchoice = document.createElement("div");
    for (var n=0; n < $neurons.length; n++) {
        var el_choice = document.createElement("div");
        el_choice.classList = "neuron-choice";
        el_dchoice.appendChild(el_choice);

        var el_choice_info = document.createElement("div");
        el_choice_info.classList = "neuron-choice-info";
        
        var nObj = $neurons[n];
        await ANNE.GUI_STUFF.disambigHTMLStr(el_choice_info, nObj);
        el_choice.appendChild(el_choice_info);
        
        var el_choice_btn = document.createElement("div");
        el_choice_btn.classList = "neuron-choice-btn-holder";  
        el_choice.appendChild(el_choice_btn);
        
        var el_btn = ANNE.A.ezButton(el_choice_btn, "", "choose match "+(n+1), "anne-tiny-btn btn-purple-sq btn-maxH", (e)=>{
            ANNE.A.empty(el_dchoice. true);//empty and hide choice div.
            var nid_x = e.target.getAttribute("nid");
            var nObjx = ANNE.MEMG.getNeuronByNid(nid_x);
            console.log("pick "+nObjx.text+" nid:"+nObjx.nid+" val '"+$val+"'");
            return ACE.CIRCUIT.userDisambiguatedContinue(nObjx, $val);
        });
        el_btn.setAttribute("nid", nObj.nid);
        el_btn.setAttribute("val", $val);
        ACE.el_console.appendChild(el_dchoice);
    }
}



/**
 * 
 */
ACE.openConsole = function() {
    ACE.eraseConsole();
    //anytime we process we open the console.
    ANNE.A.show("circuit_console");
}


ACE.addElToConsole=function($el) {
    if (ANNE.A.hasClass("circuit_console", "hide")==true) {
        ANNE.A.show("circuit_console");
    }

    if (ACE.el_console==null) ACE.el_console = document.getElementById("console_print");

    ANNE.A.show(ACE.el_console);
    ACE.el_console.appendChild($el);
    ACE.el_console.scrollTop = ACE.el_console.scrollHeight;
}


/**
 */
ACE.addToConsole=function($msg="", $bPLAYDIGITAL=true){
    if ($msg=="") return;
    if (ACE._nextValidTick!=0) {
        ACE.cQ.push($msg);
        return;
    }

    //turn on the display if it is off.
    if (ANNE.A.hasClass("circuit_console", "hide")==true) {
        ANNE.A.show("circuit_console");
    }

    ANNE.A.show(ACE.el_console);

    $bPLAYDIGITAL=false; //kamalani is sleeping!
    
    if ($bPLAYDIGITAL==true) {
        if ($msg.length>83) {
            ANNE.playSound("typing_long");
        }
        else if ($msg.length<40) {
            ANNE.playSound("typing_tiny");
        }
        else {
            ANNE.playSound("typing_short");
        }
    }
    
    var time=.1;
    var delay = 0;
    delay = 0;
    ACE._nextValidTick+=(2+ACE.ticks);
    
    var pel = document.createElement("p");
    pel.classList.add("pT");
    pel.style.color="whitesmoke";
	
    var bANIMATE=true;
    if (bANIMATE==true) {
        pel.style['-webkit-animation']='type '+time+'s '+delay+'s steps(30, end) forwards';
        pel.style['-moz-animation']='type '+time+'s '+delay+'s steps(30, end) forwards';
        pel.style['-o-animation']='type '+time+'s '+delay+'s steps(30, end) forwards';
        pel.style['animation']='type '+time+'s '+delay+'s steps(30, end) forwards';
    }

    pel.innerHTML = $msg;
    ACE.el_console.appendChild(pel);
    
    ACE.el_console.scrollTop = ACE.el_console.scrollHeight;
}


/**
 */
ACE.closeConsole=function() {
    ANNE.A.empty("console_print");
    ANNE.A.hide("circuit_console");
    ACE._bBLOCKING=false;
    var search_input = document.getElementById("anne_hsearch");
    search_input.focus();
    ACE.cQ = [];
    ACE._nextValidTick = 0;
}


/**
 * Show the redo button for an external src.
 * @param {*} $externalName 
 */
ACE.activateRedo=function($externalName="wikipedia") {
    ANNE.A.show("btn_"+$externalName+"_redo") ;   
}


/**
 */
ACE.click_standardLaunch=function($e) {
    $e.stopPropagation();
    $e.preventDefault();
    var clicked_nid = $e.target.getAttribute("nid");
    var circ = $e.target.getAttribute("circ");
    ACE.CIRCUIT.toggleByCircAndNid(circ, clicked_nid);
}


/**
 * 
 * @param {anne_neuron} $nObj 
 * @param {neuron_gen} $tgen 
 */
ACE.showNeuronDisplay=async($nObj=null, $tgen=null)=>{
    ANNE.TALK.printf_console(ANNE.TALK.BLUE, "ACE.showNeuronDisplay");
    if ($nObj==null || $tgen==null) {
        console.log("fix this");
    }

    //turn the overlay on.
    ANNE.A.show("threejs_leftOverlay");

    ACE.setLastAction();    //time stamp.

    if (ACE._showTgen!=null) {
        ANNE.A.show(ACE.el_btn_up);
    }
    else ANNE.A.hide(ACE.el_btn_up);

    ACE._showTgen = $tgen;
    ACE._showNid = $nObj.nid;
    ACE._showTNObjs.push({nObj:$nObj, tgen:$tgen});
    
    ANNE.A.show("console_close");
    ANNE.A.show("btn_chase_view");

    ANNE.A.empty(ACE.el_bebox_img);

    //make sure the neuron we are clicking has its solid lbl on.
    ACE.CIRCUIT.turnOnNeuronGui($tgen);
    ACE.CIRCUIT.turnOnAllInPath($tgen);
    
    var parentNOBJ = $nObj.getParent();

    //$nObj.printRelons();

    if (parentNOBJ==null) {
        
        //if this is a ghost we have bad data in our data maker.
        if ($nObj.ghost==false) {
            await ANNE.API.queryForOuts_not($nObj.nid, true);
            parentNOBJ = $nObj.getParent();
        }
        if (parentNOBJ==null) {
             alert("THIS SHOULD NEVER HAPPEN!!!!!!, why no parent?");
        }
    }


    if (parentNOBJ==null) {
        ANNE.A.setHTML("lo_class", "MALFORMED, NO PARENT NEURON");
        return;
    }

    var afile = await IMAGES.getBasicB64Thumb(parentNOBJ, $nObj, ACE.el_bebox_img, "", 84, 0, 84);

    //do a quick lookup to see if this was created by someone else
    //and adopted by ANNE since we last created our ghost.
    //We want to take all precautions to prevent dupe neurons being created.
    //ANNE will not adopt it and the user will be stuck with a self-owned neuron that no one uses..
    //NOTE: WE CAN ONLY TEST THIS BY CREATING A NEW THING, SWITCH USERS, CREATE SAME NEW THING, SEND TO ANNE,
    //GO BACK TO FIRST USERS FOR SAME GHOST THING, AND FIND REAL THING IN THIS FUNCTION HERE.
    //WILL BE POSSIBLE FOR COMMON AREAS WHERE PEOPLE ARE CREATING THE SAME NEW NEURONS
    //AT THE SAME TIME
    if ($nObj.ghost==true && $nObj.ghost_audit==undefined) {
        var resp = await ANNE.CHASE.getGlobal(parentNOBJ, $nObj.text);
        $nObj.ghost_audit=true;
        
        if (resp!=undefined && resp!=null && resp.result!=undefined && resp.result.length>0) {
            console.log(resp);
           
            alert("upgrade ghost to real (in gui) work to do here");
            //alter all ghost relons out/in to this neuron..
            //update the neuron to the reps.result neuron.
        }
    }

    var title_class = ANNE.A.getNeuronColorClass($nObj, "title", "", "other");


    ANNE.A.show(ACE.el_neuronDisp);
    //console.log("build out neuron display for neuron ");
    //console.log($nObj);

    var el_class = ANNE.A.setHTML("lo_class", parentNOBJ.uicoWithName());
    el_class.setAttribute("title", parentNOBJ.nid);
    
    if ($nObj.ghost==true) {
        ANNE.A.setHTML("lo_own", "(local ghost neuron)");
    }
    else {
        var ownerNOBJ = ANNE.MEMG.getNeuronByNid($nObj.owned_by);
        var el_own = ANNE.A.setHTML("lo_own", ownerNOBJ.text);
        el_own.setAttribute("title", ownerNOBJ.nid);
    }
    if ($nObj.sponsored_by && $nObj.sponsored_by!="") {
        var sponsorNOBJ = ANNE.MEMG.getOrMakeIfNew($nObj.sponsored_by);
        if (sponsorNOBJ.text=="") {
            //await ANNE.CHASE.getNid
        }
        var el_sp = ANNE.A.setHTML("lo_sp", sponsorNOBJ.bestNameHTML());
        el_sp.setAttribute("title", sponsorNOBJ.nid);
        ANNE.A.show("lo_sprow");
    }	
    else {
        ANNE.A.empty("lo_sp", true);
    }

    ANNE.A.setHTML("lo_nid", $nObj.nid);

    //$nObj.printRelons();


    var sections = [ "#merge_with_neuron, #lo_participant_section", "#lo_member_section", "#lo_member_of_section", "#lo_founder_section", 
                    "#lo_constituent_section", "#lo_constituent_of_section", "#lo_education_section",
                    "#lo_kinfolk_section", "#lo_terms_section", "#lo_external_ids_section", 
                    "#lo_group_section", "#lo_group_event_section", "#lo_misc_section",
                    "#lo_date_section", "#lo_location_section", "#lo_education_section", "#lo_military_section", 
                    "#lo_clumps_section", "#lo_tribes_section", "#lo_props_blowout"];
    
    ANNE.A.emptyAndHideMulti(sections);


    //don't kill these inner html.  just hide.
    ANNE.A.hideMulti(["#lo_person_section", "#lo_corp_section", "#lo_tribes_new"]);
    
    var bKILLALLBTNS=false;

    //lo_dossier_quick   -- populate with clickable neurons.
    //click is just like screen click of mesh/tgen.
    if ($nObj.bes[0]==MEM.person.temp_nid) {
        
        //tribal/relig/nationality
        var name = $nObj.text;
        if ($nObj.ghost==true) {
            name="<span class='ghost-small-blue-ico'></span>"+name;
            var el_mergedd = document.getElementById("merge_with_neuron");
            el_mergedd.innerHTML = "";

            //if we have a pontial mergable situation, show it in the DD.
            var aDupes = ANNE.GHOSTDATA.potentialDupes($nObj);
            if (aDupes.length>0) {
                var el_optd = document.createElement("option");
                el_optd.innerHTML="select neuron";
                el_optd.setAttribute("nid", "");
                el_mergedd.append(el_optd);
                for (var d=0; d < aDupes.length; d++) {
                    var el_opt = document.createElement("option");
                    el_opt.setAttribute("nid", aDupes[d].nid);
                    el_opt.innerHTML = aDupes[d].bestName();
                    el_mergedd.append(el_opt);
                }
                ANNE.A.show("merge_with_neuron");
            }
        }

        var el_name = ANNE.A.setHTML("lo_name", name);

        ANNE.A.show("lo_person_section");
        ACE.__doDisplayVal($nObj, "lo_birth", MEM.birthday);
        ACE.__doDisplayVal($nObj, "lo_death", MEM.deathday);
        
        //this should group kinfolk by type and show them.
        //ie, sons, daughters etc.
        
        //kinfolk
        var kinfolk = ANNE.MEMG.getKinfolk($nObj.outs);
        if (kinfolk.length) {
            ACE.__doSectionGroupByReln(kinfolk, "lo_kinfolk_section", "kinfolk");
        }

        var edu = ANNE.MEMG.getBeRelons($nObj.outs, MEM.alumni_of.temp_nid);
        if (edu.length) {
            await ACE.__doSection(edu, "lo_education_section", "education");
        }

        //people BEs participants of
        var participant = ANNE.MEMG.getBeRelons($nObj.outs, MEM.participant_of.temp_nid);
        if (participant.length) {
            await ACE.__doSection(participant, "lo_participant_section", "participant", true);
        }

        //people BEs members of
        var member = ANNE.MEMG.getBeRelons($nObj.outs, MEM.member_of.temp_nid);
        if (member.length) {
            await ACE.__doSection(member, "lo_member_of_section", "member of", "alpha");
        }
        

        var founder = ANNE.MEMG.getBeRelons($nObj.outs, MEM.founder_of.temp_nid);
        if (founder.length) {
            await ACE.__doSection(member, "lo_founder_section", "founder", "alpha");
        }

        //always do tribal, even if none yet.
        //incorrectly stored in some places as TYPE_HAS.. dagggggnabit.
        //either fix these one-offs, or handle them both.  (bullocks)
        var tribal = ANNE.MEMG.getBeOrHasRelons($nObj.outs, MEM.tribal.temp_nid);
        var tribes_nObjs = await ANNE.MEMG.getTribesArr();
        ANNE.A.show("lo_tribes_new");
        const el_tribes = await ACE.__doSectionWithSIF(tribal, tribes_nObjs, "lo_tribes_section", "tribes", "dd_tribes",
            async($selected)=> {
                console.log("selected ", $selected);
                var sNOBJ = ANNE.MEMG.getNeuronByTempNid($selected);
                if (sNOBJ==null) return;
                var tribe_relon = ANNE.MEMG.getRelonFromWithTo($nObj.outs, TYPE_BE, MEM.tribal.nid, sNOBJ.nid);
                if (tribe_relon==null) {
                    tribe_relon = ANNE.MEMG.getRelonFromWithTo($nObj.outs, TYPE_HAS, MEM.tribal.nid, sNOBJ.nid);
                }
                if (tribe_relon==null) {
                    await GHOSTDATA.makeGhostRelon(TYPE_BE, $nObj, MEM.tribal.nid, TO_TYPE_ANNE, sNOBJ);
                    ACE.____doSingle(el_tribes, sNOBJ, true);
                    ANNE.A.empty("dd_tribes");
                    ANNE.A.show("btn_editable_relons_toggle");
                }
            });
        ANNE.A.hide("dd_tribes");//edit btn will open up the SIF
        
        //terms
        var terms = ANNE.MEMG.getHasRelons($nObj.outs, MEM.service_term.temp_nid);
        if (terms.length) {
            await ACE.__doSection(terms, "lo_terms_section", "terms", "alpha");
        }

        //military
        var military_ranks = ANNE.MEMG.getHasRelons($nObj.outs, MEM.military_rank.temp_nid);
        var military_offices = ANNE.MEMG.getHasRelons($nObj.outs, MEM.military_office.temp_nid);
        var military_honours = ANNE.MEMG.getHasRelons($nObj.outs, MEM.military_honours.temp_nid);
        var mil = military_ranks.concat(military_offices);
        if (military_honours.length) mil = mil.concat(military_honours);
        if (mil.length) {
            ACE.__doSectionGroupByReln(mil, "lo_military_section", "military");
        }

        //show the ids.
        var ids = ACE.CIRCUIT.getIds($nObj.outs);
        if (ids.length) {
            ACE.__doSectionGroupByReln(ids, "lo_external_ids_section", "ids");
        }

        //tribal
        var tribal_rels = ANNE.MEMG.getBeRelons($nObj.outs, MEM.tribal.temp_nid);
        if (tribal_rels.length) ANNE.A.addEmojisFromRelTos(el_name, tribal_rels, "tribe");

        var ethnicity_rels = ANNE.MEMG.getBeRelons($nObj.outs, MEM.ethnicity.temp_nid);
        if (ethnicity_rels.length) ANNE.A.addEmojisFromRelTos(el_name, ethnicity_rels, "ethnicity");

        //nationality
        var nationality_rels = ANNE.MEMG.getBeRelons($nObj.outs, MEM.nationality.temp_nid);
        if (nationality_rels.length) ANNE.A.addEmojisFromRelTos(el_name, nationality_rels, "nationality");

        //citizenship
        var citizenship_rels = ANNE.MEMG.getBeRelons($nObj.outs, MEM.citizenship.temp_nid);
        if (citizenship_rels.length) ANNE.A.addEmojisFromRelTos(el_name, citizenship_rels, "citizenship");
    }

    else if ($nObj.bes[0]==MEM.location.temp_nid) {
        ANNE.A.setHTML("lo_name", $nObj.text);
        var elloc = ANNE.A.empty("lo_location_section");
        ANNE.A.show(elloc);

        if ($nObj.functional_be!=undefined) {
            var fbNOBJ = ANNE.MEMG.getNeuronByTempNid($nObj.functional_be);
            if (fbNOBJ!=null) {
                var coid = $nObj['be_'+MEM.constituent_of.temp_nid];
                var coNOBJ = ANNE.MEMG.getNeuronByTempNid(coid)
                if (coNOBJ!=null) {
                    var elco = document.createElement("div");
                    elco.classList = "simple-row";
                    ACE.__doSingle(elco, fbNOBJ);
                    //EXT_BTNS.makeNeuronLink(elco, fbNOBJ.nid);
                    elco.append("in");
                    ACE.__doSingle(elco, coNOBJ);
                    elloc.append(elco);
                }
            }
        }
        else {
            var coid = $nObj['be_'+MEM.constituent_of.temp_nid];
            var coNOBJ = ANNE.MEMG.getNeuronByTempNid(coid)
            if (coNOBJ!=null) {
                var elco = document.createElement("div");
                elco.classList = "simple-row";
                elco.innerHTML = "<b>located in </b>";
                ACE.__doSingle(elco, coNOBJ);
                elloc.append(elco);
            }
        }

        var constituents = ANNE.MEMG.getHasRelons($nObj.outs, MEM.constituent_of.temp_nid);
        if (constituents.length) {
            ACE.__doSectionGroupByReln(mil, "lo_location_section", "sites/locations");
        }

        //[MEM.gps_lat.temp_nid, 
        // MEM.gps_long.temp_nid, 
        // MEM.location.temp_nid,
        //MEM.site.temp_nid,
        // MEM.geo_site.temp_nid]);
    }

    else if ($nObj.bes[0]==MEM.group.temp_nid) {
        ANNE.A.setHTML("lo_name", $nObj.text);
        ANNE.A.show("lo_group_section");

        //participants of the group
        var participants = ANNE.MEMG.getHasRelons($nObj.outs, MEM.participant.temp_nid);
        if (participants.length) {
            await ACE.__doSection(participants, "lo_participant_section", "participants");
        }

        //members of the group.
        var members = ANNE.MEMG.getHasRelons($nObj.outs, MEM.member.temp_nid);
        if (members.length) await ACE.__doSection(members, "lo_member_section", "has members");
        
        //a member of another thing
        var memberOf = ANNE.MEMG.getBeRelons($nObj.outs, MEM.member_of.temp_nid);
        if (memberOf.length) await ACE.__doSection(memberOf, "lo_member_of_section", "is member of");
        
        //constituents of the group.
        var constituents = ANNE.MEMG.getHasRelons($nObj.outs, MEM.constituent.temp_nid);
        if (constituents.length) await ACE.__doSection(constituents, "lo_constituent_section", "constituents");
        
        //a constituent of another thing.
        var constituentOf = ANNE.MEMG.getHasRelons($nObj.outs, MEM.constituent_of.temp_nid);
        if (constituentOf.length) await ACE.__doSection(constituentOf, "lo_constituent_of_section", "constituent of");

        //alumnis of the group
        var edu = ANNE.MEMG.getBeRelons($nObj.outs, MEM.alumni.temp_nid);
        if (edu.length) {
            await ACE.__doSection(edu, "lo_education_section", "alumni", true);
        }
    }

    else if ($nObj.bes[0]==MEM.group_event.temp_nid) {
        ANNE.A.setHTML("lo_name", $nObj.text);
        ANNE.A.show("lo_group_event_section");
        //do start/end date
        //do location
        //maybe a desc
        
        var participants = ANNE.MEMG.getHasRelons($nObj.outs, MEM.participant.temp_nid);
        if (participants.length) {
            await ACE.__doSection(participants, "lo_participant_section", "participants", true);
        }
        var members = ANNE.MEMG.getHasRelons($nObj.outs, MEM.member.temp_nid);
        if (members.length) {
            await ACE.__doSection(members, "lo_member_section", "has members", true);
        }
    }

    //build this out as needed for companies.
    //start date, end date, products, etc. 
    else if ($nObj.bes[0]==MEM.company.temp_nid) {
        ANNE.A.setHTML("lo_name", $nObj.text);
        var corp = 0;        
        var ct_rel = ANNE.MEMG.getRelonFromWithR($nObj.outs, TYPE_BE, MEM.company_type.temp_nid);

        if (ct_rel!=null) {
            corp+=1;
            ANNE.A.show("lo_corp_type_row");
            var ctRELNOBJ = ANNE.MEMG.getNeuronByTempNid(ct_rel.t);
            var elct = ANNE.A.setHTML("lo_corp_type", ctRELNOBJ.text);
            elct.setAttribute("edit-txid", ct_rel.txid);
        }
        else {
            ANNE.A.hide("lo_corp_type_row");
            ANNE.A.empty("lo_corp_type");
        }

        if (corp>0) ANNE.A.show("lo_corp_section");

        //registration polity
        //headquarters
        //key persons
        
        var propObjs = [
            {relnNOBJ:MEM.founder, type:TYPE_HAS},
            {relnNOBJ:MEM.foundedOn, type:TYPE_BE},
            {relnNOBJ:MEM.key_person, type:TYPE_HAS},
            {relnNOBJ:MEM.hqLocation, type:TYPE_HAS},
            {relnNOBJ:MEM.registrationPolity, type:TYPE_HAS},
            {relnNOBJ:MEM.industry, type:TYPE_HAS},
        ];

        //blow out props in top section (two col)
        ACE.__propsBlowOut(propObjs);

        var edu = ANNE.MEMG.getHasRelons($nObj.outs, MEM.alumni.temp_nid);
        if (edu.length) {
            await ACE.__doSection(edu, "lo_education_section", "alumni");
        }
        
        var founders = ANNE.MEMG.getHasRelons($nObj.outs, MEM.founder.temp_nid);
        if (founders.length) await ACE.__doSection(founders, "lo_founder_section", "founders");
        
        //members of the group.
        var members = ANNE.MEMG.getHasRelons($nObj.outs, MEM.member.temp_nid);
        if (members.length) await ACE.__doSection(members, "lo_member_section", "has members");
        
        var memberOf = ANNE.MEMG.getBeRelons($nObj.outs, MEM.member_of.temp_nid);
        if (memberOf.length) await ACE.__doSection(memberOf, "lo_member_of_section", "is member of");
        
        //constituents of the group.
        var constituents = ANNE.MEMG.getHasRelons($nObj.outs, MEM.constituent.temp_nid);
        if (constituents.length) await ACE.__doSection(constituents, "lo_constituent_section", "constituents", false);
        
        //a constituent of another thing.
        var constituentOf = ANNE.MEMG.getHasRelons($nObj.outs, MEM.constituent_of.temp_nid);
        if (constituentOf.length) await ACE.__doSection(constituentOf, "lo_constituent_of_section", "constituent of", false);

    }

    else if ($nObj.bes[0]==ANNE.MEM.gregorian_date.temp_nid) {
        ANNE.A.setHTML("lo_name", $nObj.text);
        
        //TODO:  buttons:
        //get all tied to this date.  (ins)
        //get all (type of reln) tied to this date.
        if($nObj.bCHASED_ins==undefined) $nObj.bCHASED_ins = true;
        else if ($nObj.bCHASED_ins == true) {
            console.log("already chased ins.");
        } 
        else {
            $nObj.bCHASED_ins = true;
            //chase the ins here.
            //get all BEs and HAS pointing to this date.  (also any BRAIN or ROLE types)
            //of those matching neurons, get all types 0-3 relons and any BRAIN or ROLE types.
            await CHASE.chaseIns_GWV($nObj, true, [1, 3, 8, 9], [0, 1, 2, 3, 8, 9], true);
        }
        ANNE.A.show("lo_date_section");    
    }


    else {
        ANNE.A.setHTML("lo_name", $nObj.text);
        ANNE.A.show("lo_misc_section");
    }

    //***** CLUMPS ******
    //all template types can have clumps associated with them.
    ACE.__displayEvents($nObj, "lo_clumps_section", "events", "year");
    //******************/

    ANNE.A.addRemoveClasses("lo_name", title_class,  ["title-self", "title-ghost", "title-hanai", "title-other", "title-anne"]);

    //will show or hide the wikipedia / wikispooks manual repull href button in the footer.
    ACE.assessExternals($nObj);

    /********** show/hide showNeuronDisplay sub-menu of btns *********/
    //show ghosts btn only if this is a ghost or if it has ghost relons awaiting to be sent.
    if (bKILLALLBTNS==true) {
        ANNE.A.hide("btn_delete_circuit");
        ANNE.A.hide("btn_chase_view");
        ANNE.A.hide("btn_upgrade_data");
        ANNE.A.hide("btn_editable_relons_toggle");
        ANNE.A.hide("btn_dossier_view");
        ANNE.A.hide(ACE.el_btn_up);
    }
    
    else if ($nObj.ghost==true) {
        ANNE.A.show("btn_upgrade_data");
    }
    else if (ANNE.isANNE($nObj.owned_by)==false) {
        ANNE.A.show("btn_upgrade_data");
    }

    //this just tests one level deep from this neuron.
    //the circuit is indefinitely long so we can check deeper if we wanted.
    else {
        var bSHOWN = false;
        for (var r=0; r < $nObj.outs.length; r++) {
            if ($nObj.outs[r].ghost==true) {
                ANNE.A.show("btn_upgrade_data");
                bSHOWN = true;
                break;
            }
            if ($nObj.outs[r].to_type!=TO_TYPE_ANNE) continue;
            var toNOBJ = ANNE.MEMG.getNeuronByNid($nObj.outs[r].to_s);
            if (toNOBJ==null) continue;
            if (toNOBJ.hasGhostRelons()==true) {
                ANNE.A.show("btn_upgrade_data");
                bSHOWN = true;
                break;
            }
            else if (ANNE.isANNE(toNOBJ.owned_by)==false) {
                ANNE.A.show("btn_upgrade_data");
                bSHOWN = true;
                break;
            }
        }
        if (bSHOWN==false) ANNE.A.hide("btn_upgrade_data");
    }

    if (bKILLALLBTNS==false) ACE.testToShowDelete();

    return;
}


/**
 */
ACE.hideOnly = function() {
    ANNE.A.hide(ACE.el_neuronDisp);
    ACE._showNid = null;
    ACE._showTgen = null;
    ACE._showTNObjs.pop();
}


/**
 */
ACE.addImgByUrlToThumbs=function($url, $el="thumb_imgs") {
    ANNE.A.show($el);
    ANNE.A.imgButton($el, "", $url,"search-img-small", null);
}


/**
 * Called when closing a box.
 * We can show the neuron display of the last clicked after closing.. if one exists.
 */
ACE.hideNeuronDisplay=async($bHIDEMAIN=false)=>{
    ANNE.A.hide(ACE.el_neuronDisp);
    var bDONTREOPENLAST=false;
    var lastShowNid = -1;
    if (ACE._showTgen!=null && ACE._showTgen.gen==0) {
        bDONTREOPENLAST=true;
    }
    lastShowNid = ACE._showNid;
    
    //this is just a simple fix for the lbl of the neuorn we just clicked.
    ACE.CIRCUIT.turnOffNeuronGui(ACE._showTgen);

    //if we close the root history is wiped.
    if ($bHIDEMAIN==true) {
        if (ACE._showTgen!=null) {
            ACE._showTgen.circ.resetAnimating();
        }

        ACE._showTNObjs=[];  
        bDONTREOPENLAST = true;
        ACE._showNid = null;
        ACE._showTgen = null;
        return;
    }

    ACE._showNid = null;
    ACE._showTgen = null;
    
    //pop off any items in our show stack with this nid. 
    //we have turned it off.
    for (var t=0; t < ACE._showTNObjs.length; t++) {
        var tnOBJ = ACE._showTNObjs[t];
        if (tnOBJ.nObj.nid==lastShowNid) {
            ACE._showTNObjs.splice(t, 1);
            t=t-1;
            continue; 
        }
    }

    //if this wasn't a root hide, show the last open.
    if (bDONTREOPENLAST==false && ACE._showTNObjs.length) {
        ACE.showLastTNObj();
    }
}


/**
 * 
 * @param {*} $nid 
 */
ACE.neuronDeleted=function($nid) {
    console.log("ACE.neuronDeleted "+$nid);
    for (var s=0; s < ACE._showTNObjs.length; s++) {
        var showObj = ACE._showTNObjs[s];
        if (showObj.nObj.nid==$nid) {
            ACE._showTNObjs.splice(s, 1);
            s--;
        }
    }

    if (ACE._showTNObjs.length==0) return;
    
    var lastShow_obj = ACE._showTNObjs.pop(); //pop last added open obj to the stack and reshow it.
    
    if (lastShow_obj && lastShow_obj.nObj.nid==$nid) {
        ACE.goToLastTNObj()
    }
}


/**
*/
ACE.goToLastTNObj=async()=>{
    console.log("ACE.goToLastTNObj");
    if (ACE._showTNObjs.length==0) return;

    //close the open tgen. pop it from history.
    var lastShow_obj = ACE._showTNObjs.pop(); //pop last added open obj to the stack and reshow it.
    lastShow_obj.tgen.bOPEN=false;
    ACE.CIRCUIT.removeHalos(lastShow_obj.tgen);

    //we want to go back to the prev one.
    if (ACE._showTNObjs.length>0) {
        lastShow_obj = ACE._showTNObjs.pop();

        //if the last one is already open (it was in the same line..)
        //just show the neuron display
        if (lastShow_obj.tgen.bOPEN==true) {
            await ACE.showNeuronDisplay(lastShow_obj.nObj, lastShow_obj.tgen);
        }

        //otherwise open it.
        else await ACE.finalClickByTgen(lastShow_obj.tgen);
    }
    
    //if we still have more history, keep showing the back button.
    if (ACE._showTNObjs.length==0) {
        ANNE.A.hide(ACE.el_btn_up); 
    }
        
}

/**
 * little inner back ability in the graph (to easily go back to last viewable thingy) 
 */
ACE.showLastTNObj=async($bDOUBLEPOP=false)=> {
    var lastShow_obj = ACE._showTNObjs.pop(); //pop last added open obj to the stack and reshow it.
    if ($bDOUBLEPOP==true) lastShow_obj = ACE._showTNObjs.pop();
    
    console.log("neuron cloesd, %cre-displaying details for last open %c"+lastShow_obj.nObj.text, TALK.bgred, TALK.bggreen);
    await ACE.showNeuronDisplay(lastShow_obj.nObj, lastShow_obj.tgen);

    if (ACE._showTNObjs.length>1) {
        ANNE.A.hide(ACE.el_btn_up);
    }
}


ACE.shutDownSearch=function() {
    ANNE.A.hide("threejs_search_bar");
    ANNE.A.show("reset_display");
}

//target display (primary circuit buttons)
ACE.addToLog=function($el){
    ACE.el_neuronDisp.prepend($el);
}
ACE.wipeLog=function(){
    ANNE.A.hide(ACE.el_neuronDisp);
}

ACE.flipVolumePref = function() {
    console.log("test");
}


ACE.updateSun=function() {
    ACE.sun.x = 0;//Math.cos( phi );
    ACE.sun.y = 20000;//Math.sin( phi ) * Math.sin( theta );
    ACE.sun.z = 0;//Math.sin( phi ) * Math.cos( theta );
    ACE.sky.material.uniforms[ 'sunPosition' ].value.copy( ACE.sun );
    ACE.water.material.uniforms[ 'sunDirection' ].value.copy( ACE.sun ).normalize();
    ACE.scene.environment = ACE.pmremGenerator.fromScene( ACE.sky ).texture;
}


ACE.printGhostRelon = function ($rObj) {
    var typeText = ANNE.TALK.getTypeName($rObj.type);
    var fromNOBJ = ANNE.MEMG.getNeuronByNid($rObj.from_nid);	//all should be indexed
    if (fromNOBJ==null) return;
    var fromText = fromNOBJ.text;
    if (fromText=="") fromText = fromNOBJ.nid;
    var relnNOBJ = ANNE.MEMG.getNeuronByNid($rObj.reln);
    var relonText = relnNOBJ.text;
    var toText = "";
    if ($rObj.to_type==TO_TYPE_ANNE) {
        var toNOBJ = ANNE.MEMG.getNeuronByTempNid($rObj.t);
        if (toNOBJ==null) {
            console.log("????????");
            toText = $rObj.to_s;
        }
        else toText = toNOBJ.text;
    }
    else toText = $rObj.to_s;
    var ghost  ="";
    if ($rObj.ghost==true) ghost="(gh)";
    var relonStr = "["+typeText+ "] from:<b><span style='color:#09f'>"+fromText+ "</span></b>";
    relonStr=relonStr + " reln:<b><span style='color:#ff0000'>"+relonText+"<span></b>";
    relonStr=relonStr+" to: <b><span style='color:#00FF00'>"+toText+"<span></b>";
    return ghost+relonStr;
}


/**
 * This is from the test div on the right of the threejsapp
 */
ACE.updateGhostsDivTestDisplay = function() {
    var el_ghost_display = ANNE.A.empty("ghost_display");
    var relon_prints = [];
    var printed = [];
    var n_ghosts =0;
    var r_ghosts =0;
    var ghost_neurons = document.getElementById("ghost_neurons");
    var ghost_relons = document.getElementById("ghost_relons");    
    for (var g=0; g < MEM._aNeurons.length; g++) {
        if (MEM._aNeurons[g].ghost==true) {
            n_ghosts+=1;
            var nObj = MEM._aNeurons[g];
            for (var r=0; r < nObj.outs.length; r++ ) {
                if (nObj.outs[r].ghost==true) {
                    relon_prints.push(ACE.printGhostRelon(nObj.outs[r]));
                    printed.push(nObj.outs[r].txid);
                }
            }
        }
    }
    for (var g=0; g < MEM._aRelons.length; g++) {
        if (MEM._aRelons[g].ghost==true) {
            r_ghosts+=1;
            if (printed.indexOf(MEM._aRelons[g].txid)!=-1) continue;
            relon_prints.push(ACE.printGhostRelon(MEM._aRelons[g]));
            printed.push(MEM._aRelons[g].txid);
        }
    }
    if (printed.lenght>0) {
        ANNE.A.show("btn_upgrade_ghosts");
    }
    else ANNE.A.show("btn_upgrade_ghosts");

    ANNE.A.setHTML(el_ghost_display, relon_prints.join("<BR>"));
    ANNE.A.setHTML(ghost_neurons, n_ghosts);
    ANNE.A.setHTML(ghost_relons, r_ghosts);
}



ACE.isValidExternalChase=function($nObj) {
    if (ANNE.SETTINGS.bDOWIKIPEDIA==true && ($nObj.bWIKIPEDIADONE==undefined || $nObj.bWIKIPEDIADONE==false)) {
        if (ANNE.MEM_UDF.isWikipedaChaseable($nObj)==true) {
            return true;
        }
    }
    if (ANNE.SETTINGS.bDOWIKISPOOKS==true && ($nObj.bWIKISPOOKSDONE==undefined || $nObj.bWIKISPOOKSDONE==false)) {
        if (ACE.isWikispooksChaseable($nObj)==true) {
            return true;
        }
    }
    if (ACE.bTMDB_ACTIVE==true && ($nObj.bTMDBDONE==undefined || $nObj.bTMDBDONE==false)) {
        if (ACE.isTMDBChaseable($nObj)==true) {
            return true;
        }
    }
}

/**
 * 
 * @param {*} $nObj 
 */
ACE.assessExternals=function($nObj) {
    ACE.assessWIKIPEDIA();
    ACE.assessWIKISPOOKS();
    ACE.assessTMDB();
}


ACE.assessWIKIPEDIA=function() {
    if (ACE._showNid!=null && ANNE.SETTINGS.bDOWIKIPEDIA==true) {
        var showNOBJ = ANNE.MEMG.getNeuronByNid(ACE._showNid);
        if (showNOBJ.bWIKIPEDIADONE!=undefined && showNOBJ.bWIKIPEDIADONE==true) {
            ANNE.A.hide("btn_wikipedia_redo");
            return false;
        }
        if (ANNE.MEM_UDF.isWikipedaChaseable(showNOBJ)==true) {
            ANNE.A.show("btn_wikipedia_redo");
        }
        else ANNE.A.hide("btn_wikipedia_redo");
    }
    else ANNE.A.hide("btn_wikipedia_redo");
}


/**
 * 
 */
ACE.assessWIKISPOOKS=function() {
    if (ACE._showNid!=null && ANNE.SETTINGS.bDOWIKISPOOKS==true) {
        var showNOBJ = ANNE.MEMG.getNeuronByNid(ACE._showNid);
        if (showNOBJ.bWIKISPOOKSDONE!=undefined && showNOBJ.bWIKISPOOKSDONE==true) {
            ANNE.A.hide("btn_wikispooks_redo");
            return;
        }
        if (ACE.isWikispooksChaseable(showNOBJ)==true) {
            ANNE.A.show("btn_wikispooks_redo");
        }
        else ANNE.A.hide("btn_wikispooks_redo");
    }
    else ANNE.A.hide("btn_wikispooks_redo");
}


/**
 */
ACE.assessTMDB = function() {
    if (ACE._showNid!=null && ACE.bTMDB_ACTIVE==true) {
        var showNOBJ = ANNE.MEMG.getNeuronByNid(ACE._showNid);
        if (showNOBJ.bTMDBDONE!=undefined && showNOBJ.bTMDBDONE==true) {
            ANNE.A.hide("btn_tmdb_redo");
            return;
        }
        if (ACE.isTMDBChaseable(showNOBJ)==true) {
            ANNE.A.show("btn_tmdb_redo");
        }
        else ANNE.A.hide("btn_tmdb_redo");
    }
    else ANNE.A.hide("btn_tmdb_redo");
}



/**
 * 
 * @param {*} $nObj 
 * @returns 
 */
ACE.isWikispooksChaseable=function($nObj) {
    if (ACE.chaseWikispooks.length==0) return true;
    if (ANNE.MEMG.isBesOfs($nObj, ACE.chaseWikispooks)==false) return false;
    return true;
}

//these use the same array to test.
ACE.isWikidataChaseable=function($nObj) {
    if (ACE.chaseWikidata.length==0) return true;
    if (ANNE.MEMG.isBesOfs($nObj, ACE.chaseWikidata)==false) return false;
    return true;
}
ACE.isWikipediaChaseable=function($nObj) {
    if (ACE.chaseWikidata.length==0) return true;
    if (ANNE.MEMG.isBesOfs($nObj, ACE.chaseWikidata)==false) return false;
    return true;
}


//we will do this later as a on-off link click 
//for people or companies.  Not worth chasing this now..
//only payoff is movies/actors/directors/genres of movies/prod companies etc.
ACE.isTMDBChaseable=function($nObj){
    if (ACE.chaseTMDB.length==0) return true;
    if (ANNE.MEMG.isBesOfs($nObj, ACE.chaseTMDB)==false) return false;
    return true;
}


   

/**
 * 
 */
ACE.resetCSSLbls = function() {
    var elcss = ANNE.A.__getEl(ACE.elCSSid);

    //these have a compound div.  must remove the parent
    var els = elcss.querySelectorAll(".neuron-css-img");
    els.forEach(element => ANNE.A.removeSelf(element.parentNode));

    //for anne-neuron divs left, just remove them
    var els = elcss.querySelectorAll(".anne-neuron");
    els.forEach(element => ANNE.A.removeSelf(element));

    //for anne-match-neuron divs left, just remove them
    var els = elcss.querySelectorAll(".anne-match-neuron");
    els.forEach(element => ANNE.A.removeSelf(element));
    
    //remove anne reln lbl divs.
    var els = elcss.querySelectorAll(".anne-reln-lbl");
    els.forEach(element => ANNE.A.removeSelf(element));
}


/**
 * 
 */
ACE.activateCircuitBoard=function() {
    //we should animate this...
    //ACE.controls.maxPolarAngle = 0;
    //ACE.controls.minPolarAngle = 0;
    ACE.controls.minDistance = 100;
    ACE.controls.maxDistance = 20800;
    ACE.controls.minZoom = ACE._minZoom;
    ACE.controls.maxZoom = ACE._maxZoom;
    ACE.controls.zoomTo(1, false);

    //test circBoard.
    ACE.circBoard = new circuit_board(ACE.CIRCUIT);
    const boxGrid = ACE.circBoard.makeBoxGrid(20, 20, 2);
    ACE.scene.add(boxGrid); 

    ACE.controls.setTarget( 0, 2, 0 );
}


/**
 * 
 * @param {*} $e 
 * @returns 
 */
ACE.mergeNeurons=function($e) {
    console.log("merge neurons");
    var opt = $e.target.options[$e.target.selectedIndex];
    if (opt.getAttribute("nid")==undefined || opt.getAttribute("nid")=="") return;
    ACE.mergeSelected(opt);
}


/**
 * 
 * @param {*} $opt 
 * @returns 
 */
ACE.mergeSelected = async($opt)=> {
    var nid = $opt.getAttribute("nid");
    if (nid==undefined || nid=="") return;
    console.log("do inline merge with nid: "+nid);
    await ANNE.GHOSTDATA.mergeGhosts(ACE._showNid, nid);
}


ACE.onContextMenu=function($e) { // Prevent right click
    $e.preventDefault();
}

ACE.onDocumentMouseUp=function($e) {
    console.log("mouse up");
    ACE.hold = -1;
    ACE.hold_tick=0;
}

/**
 * 
 * @param {*} $e 
 */
ACE.onDocumentMouseDown=async($e)=> {
    if (ACE._bBLOCKING==true) {
        return; //save time.
    }
    
    if ($e.target.getAttribute("overlay")!=undefined) {
        return;
    }

    if ($e.target.parentElement!=undefined && $e.target.parentElement.getAttribute("overlay")!=undefined) {
        console.log("skipping event from overlay")
        return;
    }

    console.log("mouse down");

    var x = ($e.clientX / window.innerWidth) * 2 - 1;
    var y = -($e.clientY / window.innerHeight) * 2 + 1;
    var mouse = new THREE.Vector2(x, y);
    var raycaster = new THREE.Raycaster();
    raycaster.setFromCamera(mouse, ACE.camera);
    
    //no clicks on 3d stuff when we are bBLOCKING.
    if (CIRCUIT.clickableMeshes.length >0) {
        var intersects2 = raycaster.intersectObjects( CIRCUIT.clickableMeshes );
        if (intersects2.length > 0 ) {
            for (var t=0; t < intersects2.length; t++) {
                var targetObj2 = intersects2[0].object;
                if (targetObj2.tgen==undefined || targetObj2.tgen.gen==undefined) {
                    continue;
                }

                //first valid mesh is the mesh we take.
                await ACE.finalClickByTgen(targetObj2.tgen);
                break;
            }
        }
    }
}


/**
 * so we can call it from circuit..
 */
ACE.finalClickByTgen=async($tgen)=>{
    //for literals and dupes of tgens downstream in any given branch
    //we turn those black and do not let them be clicked.
    if ($tgen.bNOCLICK==true) return;
    if ($tgen.bANIMATING==true) return;
    ANNE.A.hide("btn_wikipedia_redo");
    ANNE.A.hide("btn_wikispooks_redo");
    ANNE.A.hide("btn_wikidata_redo");
    ANNE.A.hide("btn_tmdb_redo");
    if ($tgen.gen==0) {
        if ($tgen.circ.circ_id<2) {
            ACE.CIRCUIT.toggleTargetNeuron($tgen);   //no need to await this here.
        }
        else {
            ACE.CIRCUIT.compCircINST.toggleCompareCircuit($tgen);//green box click
        }
    }
    else {
        //console.log("a neuron has been clicked");
        await CIRCUIT.toggleSubGen($tgen);
    }
}


/**
 * Attempting to save resource when this hypergraph scene is not showing..
 * don't want to load/reload it again and again as the ACE is a module-like
 * object.  So --- will attempt to properly disable/enable when required.
 */
ACE.disable = function() {
    ANNE.TALK.printf_console(ANNE.TALK.RED, "ACE.disable");
    ACE.bDISABLED=true;
    cancelAnimationFrame(ACE.animationLoopId);
    window.removeEventListener( 'resize', ACE.onWindowResize, false );
    document.removeEventListener( 'pointerdown', ACE.onDocumentMouseDown, false );
}
ACE.enable = function() {
    if (ACE.bDISABLED==false) return;
    ANNE.TALK.printf_console(ANNE.TALK.RED, "ACE.enable");
    ACE.bDISABLED=false;
    ACE.animationLoopId = requestAnimationFrame(ACE.animate);
    window.addEventListener( 'resize', ACE.onWindowResize, false );
    document.addEventListener( 'pointerdown', ACE.onDocumentMouseDown, false );
}


/**
 * dummy place to load up test locations when encountering patterns our 
 * handling can't figure out.
 */
ACE.testLocations = async()=> {
    var locations = [
        "Chicago, Illinois, USA"];
        for(var t=0; t < locations.length; t++) {
            var loc = new anne_location(locations[t]);  
            await loc.processFull();
            loc.print();
        }
}


ACE.onWindowResize=function() {
    ANNE.TALK.printf_console(ANNE.TALK.RED, "ACE.onWindowResize");
    ACE.camera.aspect = window.innerWidth / window.innerHeight;
    ACE.camera.updateProjectionMatrix();
    ACE.renderer.setSize( window.innerWidth, window.innerHeight );
    ACE.rendererCSS.setSize( window.innerWidth, window.innerHeight );
}


ACE.animate=function() {
    ACE.animationLoopId = requestAnimationFrame( ACE.animate );

    if (ACE.hold==1) {
        ACE.hold_tick+=1;
        var direction = new THREE.Vector3();
        ACE.camera.getWorldDirection(direction);
        var distance = 2;// Math.pow(2, ACE.hold_tick)/10;
        ACE.camera.position.add( direction.multiplyScalar(distance) );
        if (ACE.camera.position.y <10) ACE.camera.position.y=10;
        console.log(ACE.hold_tick);
    }

    if (ACE.clock==undefined || ACE.clock==null) {
        console.warn("SOMETHING WENT WRONG, WE'RE GOING BACK!");
        ACE.disable();
        ANNE.MEM_UDF.hide3js();
        ANNE.MEM_UDF.goToPrev();
        return;    
    }
    
    const delta = ACE.clock.getDelta();
	const hasControlsUpdated = ACE.controls.update( delta );

    if (ACE._bBLOCKING==true) {
        ACE.controls.azimuthAngle += -1 * delta * THREE.MathUtils.DEG2RAD;
    }

    if (ACE._nextValidTick!=0 && ACE.cQ.length>0 && ACE._nextValidTick<=ACE.ticks) {
        var msg = ACE.cQ.shift();
        ACE._nextValidTick = 0;
        ACE.addToConsole(msg);
    }

    ACE.render();
}

ACE.render=function() {
    ACE.ticks+=1;
     
    //have the lbls always looking at the camera.
    for (var c = 0; c  < CIRCUIT.css3dLbls.length; c++) {
        if (CIRCUIT.css3dLbls[c].bOPEN==false) continue;
        CIRCUIT.css3dLbls[c].lookAt(ACE.camera.position);
    }

    //is this even being done anymore????
    for (var m=0; m < CIRCUIT._imgs.length; m++) {
        CIRCUIT._imgs[m].lookAt(ACE.camera.position);
    }

    if (ACE.camera.position.y<10) ACE.camera.position.y=10;

    ACE.water.material.uniforms[ 'time' ].value += 1.0 / 60.0;
    ACE.renderer.render( ACE.scene, ACE.camera );
    ACE.rendererCSS.render( ACE.scene, ACE.camera );
}    


//shouldn't be too many multiples in here...
//this is a two col display, not a section.
ACE.__propsBlowOut = function($propsObjs) {
    var elp = ANNE.A.empty("lo_props_blowout");
    var elps = 0;
    
    for (var p=0; p < $propsObjs.length; p++) {
        var relnNOBJ = $propsObjs[p].relnNOBJ;
        var type = $propsObjs[p].type;  //reln type.
        var rels = ANNE.MEMG.getRelonsFromWith2(relnNOBJ.outs, type, relnNOBJ.temp_nid);
        if (rels.length) {
            console.log("blowing out prop "+relnNOBJ.text);
            elps+=1;
            var elrow = document.createElement("div");
            elrow.classList = "disp-row";
            elrow.setAttribute("overlay", true);
            elp.appendChild(elrow);

            var ellbl = document.createElement("div");
            ellbl.classList = "disp-col-lbl";
            ellbl.innerHTML = relnNOBJ.text;
            elrow.appendChild(ellbl);

            var eldata = document.createElement("div");
            eldata.classList = "disp-col-val";
            elrow.appendChild(eldata);
           
            for (var r=0; r < rels.length; r++) {
                var rel=rels[r];
                var toNOBJ=ANNE.MEMG.getOrMakeIfNew(rel.to_s); 
                var bDOPIPE = false;
                if (r<rels.length-1) bDOPIPE=true;
                ACE.__doSingle(eldata, toNOBJ, bDOPIPE);    
            }
        }
    }
    
    if (elps>0) ANNE.A.show(elp);
}



//clump outs from nObj or .ins from roles.
ACE.__displayEvents=async($nObj, $el, $title="events", $groupBy="year")=> {
    var clump_nids = ANNE.MEMG.getAllClumpNids($nObj.outs);
    for (var i=0; i < $nObj.ins.length; i++) {
        //already have it from a clump reference
        if (clump_nids.indexOf($nObj.ins[i].from_nid)!=-1) continue;
        var fromNOBJ = ANNE.MEMG.getNeuronByTempNid($nObj.ins[i].f);
        if (fromNOBJ==null) continue;
        if (ANNE.MEM.isECAction(fromNOBJ)==true) {
            clump_nids.push(fromNOBJ.nid);
        }
    }

    if (clump_nids.length==0) {
        //console.log(" this neuron is not involved in any event clumps");
        return;
    }

    ANNE.A.show($el);
    var el_section = ACE.__headerDetailsSection($el, $title, clump_nids.length);
    var clumpNOBJS = [];
    for (var c=0; c < clump_nids.length; c++) {
        var clumpNOBJ = ANNE.MEMG.getNeuronByNid(clump_nids[c]);
        if (clumpNOBJ==null) continue;

        //overkill?  We just want the when role and need to lookup the clumps.
        //await clumpNOBJ.processActionNeuron();  

        clumpNOBJS.push(clumpNOBJ);
    }

    //just sort by the when.
    if ($groupBy=="none") {
        UTILS.sortClumpsByWhen(clumpNOBJS);    
    }
    
    var el_events  = ANNE.A.ezEl(el_section, "div", "events-holder");
    for (var e=0; e < clumpNOBJS.length; e++) {
        var evtNOBJ = clumpNOBJS[e];
        var el_clump = document.createElement("div");
        el_clump.classList = "event-clump";
        el_clump.classList.add("smart_"+evtNOBJ.temp_nid);
        el_clump.id="event_clump_nid_"+evtNOBJ.nid;
        el_events.append(el_clump);

        if (evtNOBJ.role_when!=undefined && evtNOBJ.role_when!=null) {
            var lbl = document.createElement("span");
            el_clump.appendChild(lbl);
            lbl.classList="disp-lbl";
            //if (UTILS.isset(relNOBJ._uico)==true) ico = relNOBJ._uico;
            var dateNOBJ = ANNE.MEMG.getNeuronByNid(evtNOBJ.role_when[0].to_s);
            if (dateNOBJ!=null) lbl.innerHTML = dateNOBJ.text;
            else lbl.innerHTML = "unk date"
        }
        
        var link_class = ANNE.A.getLinkColorClass(evtNOBJ);
        var sp = ANNE.A.ezSpan2(el_clump, "", link_class, evtNOBJ.text, ($e)=>{
            $e.stopPropagation();
            $e.preventDefault();
            var clicked_nid = $e.target.getAttribute("nid");
            ACE.CIRCUIT.toggleByCircAndNid(ACE._showTgen.circ, clicked_nid);
        });
        sp.setAttribute("overlay", true);
        sp.setAttribute("nid", evtNOBJ.nid);
        //if (n<clumpNOBJS.length-1) {
            // var pipe = document.createElement("span");
            // pipe.innerHTML="&nbsp;|&nbsp;";
            // elClump.appendChild(pipe);
        //}
    }
    
    //NOTE --> would be nice to display the references here (any supporting links/imgs/files)
    //that backup/document the clump. (source of info)
    //that could be displayed if the neuron is a clump
}
    
ACE.__doSingle = function($el, $nObj, $bDOPIPE=false) {
    var link_class = ANNE.A.getLinkColorClass($nObj);
    var sp = ANNE.A.ezSpan2($el, "", link_class, $nObj.text, ($e)=>{
        $e.stopPropagation();
        $e.preventDefault();
        var clicked_nid = $e.target.getAttribute("nid");
        ACE.CIRCUIT.toggleByCircAndNid(ACE._showTgen.circ, clicked_nid);
    });
    sp.setAttribute("nid", $nObj.nid);
    if ($bDOPIPE==true) {
        var pipe = document.createElement("span");
        pipe.innerHTML="&nbsp;|&nbsp;";
        sp.appendChild(pipe);
    }
    sp.setAttribute("overlay", true);
}


//simple display of neuron (or literal) value if it exists.
ACE.__doDisplayVal = function($nObj, $elid, $relnNOBJ) {
    var rel = ANNE.MEMG.getAnyRelonWithR($nObj.outs, $relnNOBJ.temp_nid);
    if (rel!=null) {
        var dtxt = ANNE.MEMG.__MASTER_DISPLAY_RELON_TO(rel);
        ANNE.A.setHTML($elid, dtxt);
    }
    else ANNE.A.empty($elid);  //should allow for edit
}

ACE.__headerDetailsSection=function($el, $title, $cnt=0){
    var el = ANNE.A.__getEl($el);
    if (el==null) return null;
    var el_header = document.createElement("div");
    el_header.classList.add("disp-row-header");
    el_header.innerHTML = $title+"<span style='color:#fefe17; font-size:.7rem;'>&nbsp;"+ANNE.UTILS.commas($cnt)+"</span>";
    el.appendChild(el_header);
    var el_details = document.createElement("div");
    el_details.classList.add("disp-section");
    el.appendChild(el_details);
    return el_details;
}


ACE.__doSectionWithSIF=async($rels, $nObjs, $section, $title, $el_sif_input, $selectedCb=null)=> {
    var el_tribes = await ACE.__doSection($rels, $section, $title, false);
    var el_sif = ANNE.A.__getEl($el_sif_input);
    el_sif.value = "";

    //wipe the existing sif stuff other than the sif input.  We will regen each time.
    for (let i = el_sif.parentNode.children.length - 1; i >= 0; i--) {
        const child = el_sif.parentNode.children[i];
        if (child !== el_sif) {
            el_sif.parentNode.removeChild(child);
        }
    }
    ANNE.A.makeANNE_SIF($el_sif_input, 
            async($str)=>{
                if ($str.length>0) {
                    return await CHASE.anne_naked_neuron_search($str, true, [NTYPE_CLASS, NTYPE_INST]);
                }
                return [];
            }, 
            async($e)=> {
                var val = $e.target.value;
                if (val.length>1) {
                    return await CHASE.anne_naked_neuron_search(val, false, [NTYPE_CLASS, NTYPE_INST]);
                }
                return [];
            }, 
            $selectedCb,
            $nObjs, 2099, false);   //don't want find more btn to show up.
    return el_tribes;
}



ACE.__doSection=async($rels, $section, $title, $bSORTALPHA=true)=> {
    var el_disp_sect = ANNE.A.show($section);
    var el_section = ACE.__headerDetailsSection(el_disp_sect, $title, $rels.length);
    if ($rels.length==0) return el_section;
    var neurons = [];
    var missing_text = [];
    for (var r=0; r < $rels.length; r++) {
        var rel=$rels[r];
        var toNOBJ=ANNE.MEMG.getNeuronByTempNid(rel.t);
        if (toNOBJ==null) continue;
        if (toNOBJ.text=="") missing_text.push(toNOBJ.nid);
        neurons.push(toNOBJ);
    }

    var final_missing = [];
    
    if (missing_text.length) {
        console.log("we have missing data on "+missing_text.length+" neurons. DO IDB PULL");
        var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOutsAndInsFroms", "blah");
        ANNE.MEM_UDF.openSubHunt("queryForOutsAndInsFroms");
        await ANNE.IDB.queryForOutsAndInsFroms(phObj, missing_text, []); //all types pull from IDB mem.
        ANNE.MEM_UDF.closeSubHunt();
        var final_missing=[];
        for (var m=0; m < missing_text.length; m++) {
            var nObj2 = ANNE.MEMG.getNeuronByNid(missing_text[m]);
            if (nObj2.text=="") final_missing.push(nObj2.nid);
        }
    }
    
    //we need to lookup these items.
    //we shouldn't have to do this.  bullocks.
    if (final_missing.length>0) {
        //console.log("we still have %cmissing data on "+final_missing.length+" neurons", ANNE.TALK.bgbigred);
        //await ANNE.CHASE.queryForOutsFroms_not(final_missing, true);
    }

    if (neurons.length>30 && $bSORTALPHA==true) {
        var obj_lbls = new Object();
        var nids = [];
        for (var n=0; n < neurons.length; n++) {
            var toNOBJ=neurons[n];
            if (toNOBJ==null) continue;
            
            //unique entires. (no dupes);
            if (nids.indexOf(toNOBJ.nid)!=-1) continue;
            nids.push(toNOBJ.nid);

            var parts = toNOBJ.text.split(" ");
            var last_part = parts.pop();
            if (UTILS.isUSSuffix(last_part)==true) {
                last_part = parts.pop();
            }
            last_part.trim();
            
            var L = last_part.substring(0,1).toUpperCase();
            if (last_part=="" || last_part==" ") {
                L = "other";
            }
            else L = last_part.substring(0,1).toUpperCase();

            if ("ABCDEFGHIJKLMNOPQRSTUVWXYZ".indexOf(L)==-1) {
                L = "other";
            }
            if (obj_lbls[L]==undefined) {
                obj_lbls[L] =[toNOBJ];
            }
            else {
                obj_lbls[L].push(toNOBJ);
            }
        }
    
        //alpha by last name
        for (var a=0; a < 27; a++) {
            var charcode = a+65;
            var char = String.fromCharCode(charcode);
            if (a==26) {//last index is for other (nums and no text)
                if(obj_lbls["other"]==undefined) continue;
                char = "other";
            }
            else if (obj_lbls[char]==undefined) continue;
            
            var blk = ANNE.A.ezSpan2(el_section, "", "alpha-letter-title", char);
            blk.style.display="block";

            var nObjs = obj_lbls[char];
            var setel = ANNE.A.ezSpan2(el_section, "", "");
            setel.style['padding-right']='3px';
            //console.log("%c letter "+char+" neurons "+nObjs.length, TALK.bggreen, TALK.bgyellow);
            
            for (var n=0; n < nObjs.length; n++) {
                var nObj = nObjs[n];
                var link_class = ANNE.A.getLinkColorClass(nObj);
                var text = nObj.text;
                if (text=="") text = nObj.nid;
                var sp = ANNE.A.ezSpan2(setel, "", link_class, nObj.text, ($e)=>{
                    $e.stopPropagation();
                    $e.preventDefault();
                    var clicked_nid = $e.target.getAttribute("nid");
                    ACE.CIRCUIT.toggleByCircAndNid(ACE._showTgen.circ, clicked_nid);
                });
                sp.setAttribute("nid", nObj.nid);
                if (n<neurons.length-1) {
                    var pipe = document.createElement("span");
                    pipe.innerHTML="&nbsp;|&nbsp;";
                    setel.appendChild(pipe);
                }
            }
        }
        return el_section;
    }

    if ($bSORTALPHA==true) {
        neurons.sort( UTILS.sortByTextNoCase);
    }
    
    var blk = ANNE.A.ezSpan2(el_section, "", "alpha-letter-title");
    blk.style.display="block";
    
    for (var n=0; n < neurons.length; n++) {
        var toNOBJ=neurons[n];
        if (toNOBJ==null) continue;
        var link_class = ANNE.A.getLinkColorClass(toNOBJ);
        var sp = ANNE.A.ezSpan2(blk, "", link_class, toNOBJ.text, ($e)=>{
            $e.stopPropagation();
            $e.preventDefault();
            var clicked_nid = $e.target.getAttribute("nid");
            ACE.CIRCUIT.toggleByCircAndNid(ACE._showTgen.circ, clicked_nid);
        });
        sp.setAttribute("nid", toNOBJ.nid);
        if (n<neurons.length-1) {
            var pipe = document.createElement("span");
            pipe.innerHTML="&nbsp;|&nbsp;";
            blk.appendChild(pipe);
        }
        sp.setAttribute("overlay", true);
        
    }
    return el_section;
}

    
ACE.__doSectionGroupByReln=function($rels, $section, $title) {
    var el_disp_sect = ANNE.A.show($section);
    var el_section = ACE.__headerDetailsSection(el_disp_sect, $title, $rels.length);
    var rel_groups = {};
    for (var r=0; r < $rels.length; r++) {
        var rel=$rels[r];
        if (rel_groups[ rel.r]==undefined) rel_groups[rel.r] = [rel];
        else rel_groups[rel.r].push(rel);
    }
    var keys = Object.keys(rel_groups);
    for (var k=0; k < keys.length; k++) {
        var rels = rel_groups [ keys[k] ];
        var relNOBJ = ANNE.MEMG.getNeuronByTempNid(keys[k]);
        
        var blk = document.createElement("div");
        blk.style.display="block";
        el_section.appendChild(blk);

        var lbl = document.createElement("span");
        blk.appendChild(lbl);
        lbl.classList="disp-lbl";
        var ico = "";
        //if (ANNE.UTILS.isset(relNOBJ._uico)==true) ico = relNOBJ._uico;
        lbl.innerHTML = ico+relNOBJ.text;

        for (var r=0; r < rels.length; r++) {
            var rel2 = rels[r];
            var toNOBJ=ANNE.MEMG.getNeuronByTempNid(rel2.t);
            if (toNOBJ==null) continue;
            var link_class = ANNE.A.getLinkColorClass(toNOBJ);
            var sp = ANNE.A.ezSpan2(blk, "", link_class, toNOBJ.text, ($e)=>{
                $e.stopPropagation();
                $e.preventDefault();
                var clicked_nid = $e.target.getAttribute("nid");
                console.log("clicked nid "+clicked_nid);
                //PROBLEM --> we need more info to find the right tgen..
                //hmmm.
                ACE.CIRCUIT.toggleByCircAndNid(ACE._showTgen.circ, clicked_nid);
            });
            
            sp.setAttribute("nid", toNOBJ.nid);
            if (r<rels.length-1) {
                var pipe = document.createElement("span");
                pipe.innerHTML="&nbsp;|&nbsp;";
                blk.appendChild(pipe);
            }
            sp.setAttribute("overlay", true);
        
        }
    }
}

