var scripts = [];
var pre = "./js/";
var version = "0.9"+Math.random();

scripts.push({name:"signumbundle3", ref:pre+"signum/", blocking:true});
scripts.push({name:"ANNEjs_aon.min", forcenew:false, ref:pre, blocking:true});

var blocking = 0;
var loaded = 0;
var loaded_needed = 0;
//load all nonblockers
var dononblockers=async($arr, $verbose=false)=>{
    for (var a=0; a < $arr.length; a++) {
        loadItFast($arr[a], $verbose); //dont await
    }
}

var doblockers=async($arr, $verbose=false)=>{
    loaded_needed = $arr.length;
    loaded = 0;
    return new Promise((resolve, reject) => {
        for (var a=0; a < $arr.length; a++) {
            loadIt($arr[a], (e)=>{
                //console.log(loaded+" vs "+loaded_needed);
                if (loaded==loaded_needed) {
                    resolve(true);
                }
            },$verbose); 
        }
    });
}

var loadItFast=async($script, $verbose=false)=> {
    const existingScript = document.getElementById($script.name);
    if (existingScript) return;
    var ref = $script.ref+$script.name+".js";
    let myScript = document.createElement("script");
    if ($script.forcenew==true) ref = ref+"?v="+version;
    document.head.appendChild(myScript);
    myScript.src = ref;
    myScript.id = $script.name+"_loadid";
    if ($verbose) console.log("loaded  fast "+myScript.id); 
    return;
}

var loadIt=async($script, $doneCallback, $verbose=false)=> {
    const existingScript = document.getElementById($script.name);
    if (existingScript) {
        if ($verbose) console.log("DUPE "+$script.name);
        loaded+=1;
        $doneCallback();
        return;// scriptLooper($callback, $verbose);
    }
    //return new Promise((resolve, reject) => {
        //console.log("load "+$script.name);
        var ref = $script.ref+$script.name+".js";
        let myScript = document.createElement("script");
        if ($script.forcenew==true) ref = ref+"?v="+version;
        
        //console.log(script.name + " is blocking.. blocking:"+blocking);
        document.head.appendChild(myScript);
        myScript.onload = async()=> {
            loaded+=1;
            if ($verbose) console.log("cb "+myScript.id+" loaded:"+loaded);
            $doneCallback();
            //resolve(true);
        }
        
        myScript.src = ref;
        myScript.id = $script.name+"_loadid";
    //});
}

var LOADER = {};
LOADER.initScriptLoads = async($callback, $verbose=false)=> {
    if ($verbose) console.log("loadings scripts:"+scripts.length);
    var blockscripts = [];
    var nonblockingscripts = []
    for (var s=0; s < scripts.length; s++) {
        if (scripts[s].blocking==true) blockscripts.push(scripts[s]);
        else nonblockingscripts.push(scripts[s]);
    }
    
    //must load these first.
    await doblockers(blockscripts, $verbose);
    dononblockers(nonblockingscripts, $verbose);

    $callback();
}

LOADER.injectForWD=async()=>{
    var sc = [];
    sc.push({name:"connector", forcenew:false, ref:"./js/network/connectors/", blocking:true});
    sc.push({name:"wikidata_connector", forcenew:false, ref:"./js/network/connectors/", blocking:true});
    sc.push({name:"tmdb_connector", forcenew:false, ref:"./js/network/connectors/", blocking:true});
    sc.push({name:"tracker_map", forcenew:false, ref:"./js/network/connectors/", blocking:true});
    sc.push({name:"wikispooks", forcenew:false, ref:"./js/network/connectors/", blocking:true});
    
    LOADER.bWD_injected=true;
    await doblockers(sc);
    return;
}