var scripts = [];
var pre = "./js/";
var version = "0.9"+Math.random();

scripts.push({name:"signumbundle3", ref:pre+"signum/", blocking:true});
scripts.push({name:"ANNEjs_be", forcenew:false, ref:pre, blocking:true});


var blocking = 0;
var loaded = 0;
var loaded_needed = 0;

//load all nonblockers
var dononblockers=async($arr)=>{
    for (var a=0; a < $arr.length; a++) {
        loadItFast($arr[a]);
    }
}

var sleep=async($ms)=>{
    return new Promise(resolve => setTimeout(resolve, $ms));
}

var doblockers=async($arr)=>{
    return new Promise(async(resolve, reject) => {
        var loaded_needed = $arr.length;
        var loaded = 0;

        for (var a=0; a < $arr.length; a++) {
            await inner($arr[a]);
            loaded+=1;
            if (loaded==loaded_needed) {
                resolve(true);
            }
        }
    });
}

var inner=async($script)=>{       
    await loadIt($script); 
}

var loadItFast=async($script)=> {
    const existingScript = document.getElementById($script.name);
    if (existingScript) return;
    var ref = $script.ref+$script.name+".js";
    let myScript = document.createElement("script");
    if ($script.forcenew==true) ref = ref+"?v="+version;
    document.head.appendChild(myScript);
    myScript.src = ref;
    myScript.id = $script.name+"_loadid";
    return;
}

var loadIt=async($script, $doneCallback)=> {
    const existingScript = document.getElementById($script.name);
    if (existingScript) {
        loaded+=1;
        $doneCallback();
        return;
    }
    
    return new Promise(async(resolve, reject) => {
        var ref = $script.ref+$script.name+".js";
        let myScript = document.createElement("script");
        if ($script.forcenew==true) ref = ref+"?v="+version;
        
        document.head.appendChild(myScript);
        myScript.onload = async()=> {
            loaded+=1;
            return resolve(true);
        }
        
        myScript.src = ref;
        myScript.id = $script.name+"_loadid";
    });
}

var LOADER = {};
LOADER.initScriptLoads = async($callback)=> {
    var blockscripts = [];
    var nonblockingscripts = []
    for (var s=0; s < scripts.length; s++) {
        if (scripts[s].blocking==true) blockscripts.push(scripts[s]);
        else nonblockingscripts.push(scripts[s]);
    }
    
    //must load these first.
    await doblockers(blockscripts);
    dononblockers(nonblockingscripts);

    $callback();
}
