//AD.ADF_SWAP.ADMIN_PENDING_MM = DB_adfswap_adminPendingMMs.sh
//AD.ADF_SWAP.ADMIN_ACTIVATE_MM = DB_adfswap_adminActivateMM.sh

var MIDMANNAGE = {};
MIDMANNAGE.defaultTargetNodeNid="14270667173691107670";  //node that is the primary proivder of the ADF SWAP app.

//anne dev fund public key.
MIDMANNAGE.ADF_PUB_KEY = "7444e77e865970388bc20009cc8f571bfe466367319b3db5435d4fabb807e37f";
MIDMANNAGE.TARGET_NODE_PUB_KEY = "77f7571e3378c20c5f259a438a1650d50f9093025783022fc7cc127f8b802547";

MIDMANNAGE.bch_node_online=false;
MIDMANNAGE.bch_node_synced=false;
MIDMANNAGE.bch_blocks=0;
MIDMANNAGE.annode_online = false;
MIDMANNAGE.annode_livemode = false;
MIDMANNAGE.annode_mode = null;

MIDMANNAGE.ANNE_ACCTID = "7777770163980908667";    
MIDMANNAGE.ANNE_ADMIN_ACCTID = "7777771543345157118";
MIDMANNAGE.ANNE_ADMIN_BACKUP_ACCTID = "7777044340734581180";
MIDMANNAGE.ADF_NID = "7770353147211057540";
MIDMANNAGE.mr_scatman = "777776301542347271";
MIDMANNAGE.johnny5 = "7777798716640079675";
MIDMANNAGE.nikt = "7777111323427337713";

MIDMANNAGE.subtypes = ["ADMIN_PENDING_MM","ADMIN_ACTIVATE_MM"];

MIDMANNAGE.admin_nids = [
    MIDMANNAGE.ANNE_ACCTID,
    MIDMANNAGE.ANNE_ADMIN_ACCTID,
    MIDMANNAGE.ANNE_ADMIN_BACKUP_ACCTID,
    MIDMANNAGE.ADF_NID,
    MIDMANNAGE.mr_scatman,
    MIDMANNAGE.johnny5,
    MIDMANNAGE.nikt, "15311846137178181917", "3335428363642379628", "9759516720522202572"
];

MIDMANNAGE.setBCHStatus=function() {
    if (MIDMANNAGE.bch_node_online==true) {
        if (MIDMANNAGE.bch_node_synced==true) {
            var elbchstatus=ANNE.A.setHTML("bchnode_status", "LIVE");
            if (elbchstatus!=null) elbchstatus.classList="LIVE";
        }
        else {
            var elbchstatus=ANNE.A.setHTML("bchnode_status", "SYNC");
            if (elbchstatus!=null) elbchstatus.classList="SYNC";
        }
    }
    else {
        var elbchstatus=ANNE.A.setHTML("bchnode_status", "OFFLINE");
        if (elbchstatus!=null) elbchstatus.classList="OFFLINE";
    }
}


/**
 * 
 */
MIDMANNAGE.init = async()=> {
    ANNE.A.show("top_info");
    ANNE.A.show("pending_div");
    ANNE.A.show("main_refresh_div");

    MIDMANNAGE.annode_mode = await ANNE.API.getAnnodeDetail("annode_mode");
    var el_status = ANNE.A.setHTML("annode_status", MIDMANNAGE.annode_mode.replace(" ", "-"));
    el_status.classList  = MIDMANNAGE.annode_mode;
    var last_anne_height = await ANNE.API.getAnnodeDetail("height");
    ANNE.A.setHTML("anne_height", last_anne_height);
    ANNE.A.show("mm_header_middle");
    if (MIDMANNAGE.admin_nids.indexOf(ANNE.USER._userNObj.nid)==-1) {
        console.warn("CANT USER THIS");
        alert("this nid cannot use this app.  It will be rejected by the alt data network.");
        return;
    }
    MIDMANNAGE.reconnectSocket();

    var refresh_pending_inner = document.getElementById("refresh_pending_inner");
    refresh_pending_inner.addEventListener("click", async(e)=>{
        ANNE.playSound("beep");
        ANNE.A.addClass("refresh_pending_inner", "spinnerself");
        MIDMANNAGE.getPendings(MIDMANNAGE.defaultTargetNodeNid);
    });

    MIDMANNAGE.getPendings(MIDMANNAGE.defaultTargetNodeNid);
}



/**
 * all swap data from sockets comes here.
 * @param {*} $json 
 * @returns 
 */
MIDMANNAGE.cb_swapdata =async($json)=>{
    if ($json.adtype!="ADF_SWAP") return;
    var subtype = $json.adsubtype;
    if (subtype && subtype.length>0) console.log("subtype:"+subtype);
    if (subtype==undefined) return;

    //not our com.
    if (MIDMANNAGE.subtypes.indexOf(subtype)==-1) return;

    var adpayload = $json.adpayload;
    if (adpayload==undefined || adpayload==null) return;

    if (adpayload.bch_node_online!=undefined && adpayload.bch_node_synced!=undefined) {
        MIDMANNAGE.bch_node_online=adpayload.bch_node_online;
        MIDMANNAGE.bch_node_synced=adpayload.bch_node_synced;
        MIDMANNAGE.bch_blocks=adpayload.blocks;
        MIDMANNAGE.setBCHStatus();
        ANNE.A.setHTML("BCH_blocks", MIDMANNAGE.bch_blocks);
    }
    
    var results=adpayload.results;
    if (results==undefined || results==null) {
        if (adpayload.data_string!=undefined && adpayload.nonce_string!=undefined) {
            var privKeyHex = await ANNE.USER.getPrivKeyHex();
            if (privKeyHex==null) {
                alert("cannot decrypt msg, cannot ascertain private key");
                return;
            }
            var decrypted = await ANNE.USER.decryptJSONEncryptedFromANNODE(adpayload.nonce_string, adpayload.data_string, MIDMANNAGE.TARGET_NODE_PUB_KEY, privKeyHex);
            console.log(decrypted);
            results = decrypted.results;    //these are the history records
         
            if (decrypted.bch_node_online!=undefined) {
                MIDMANNAGE.bch_node_online = decrypted.bch_node_online;
            }
            if (decrypted.bch_node_synced!=undefined) {
                MIDMANNAGE.bch_node_synced = decrypted.bch_node_synced;
            }
            if (decrypted.blocks!=undefined) {
                MIDMANNAGE.bch_blocks = decrypted.blocks;
            }
            MIDMANNAGE.setBCHStatus();
            ANNE.A.setHTML("BCH_blocks", MIDMANNAGE.bch_blocks);
            ANNE.A.removeClass("refresh_pending_inner", "spinnerself");
        }
        else return;
    }
    
    if (adpayload.bch_node_online!=undefined && adpayload.bch_node_synced!=undefined) {
        ADF_OTC_SWAP.bch_node_online=adpayload.bch_node_online;
        ADF_OTC_SWAP.bch_node_synced=adpayload.bch_node_synced;
        ADF_OTC_SWAP.bch_blocks=adpayload.blocks;
        ADF_OTC_SWAP.setBCHStatus();
        ANNE.A.setHTML("BCH_blocks", ADF_OTC_SWAP.bch_blocks);
    }

  

    //these are not streaming -- they are requested.
    if(subtype=="ADMIN_PENDING_MM" && results!=null) {
        console.log("ADMIN_PENDING_MM");
        ANNE.A.removeClass("refresh_pending_inner", "spinnerself");
        ANNE.A.emptySelf("pending_inner");

        if (results.length) {
            console.log(results);

            //empty pending.
            //redo it all each display.
            for (var r2=0; r2 < results.length; r2++) {
                MIDMANNAGE.gui_addPending(results[r2]);
            }    
        }
    }

    else if (subtype=="ADMIN_ACTIVATE_MM") {
        if (results.length) {
            var rez = results[0];
            ANNE.A.spinnerInject("admin_spinner_"+rez.midmanne_id);
            if (rez.status=="DECLINE") {
                ANNE.playSound("sad");
                ANNE.A.removeSelf("pending_"+rez.midmanne_id);
            }
            else {
                ANNE.playSound("success");
                ANNE.A.setHTML("aa_"+rez.midmanne_id, rez.ACTIVATIONCODE);
            }
        }
    }
}


/**
 * 
 * @returns 
 */
MIDMANNAGE.reconnectSocket=async()=>{
    //force resubscribe.. for testing (to be safe)
    //ANNE.SUBSCRIBER.bALTDATASOCKET_ON=false;
    if (ANNE.SUBSCRIBER.bALTDATASOCKET_ON==true) return;
    await ANNE.SUBSCRIBER.subscribeToAltData("ADF_SWAP", "", null, MIDMANNAGE.cb_swapdata);
}



/**
 * 
 * @param {*} $chobj 
 * @returns 
 */
MIDMANNAGE.gui_addPending = function($chobj) {
    var el_ch = document.getElementById("pending_inner");
    if (el_ch==null) {
        return;
    }

    var divpending = document.createElement("div");
    divpending.setAttribute("id", "pending_"+$chobj.midmanne_id);
    divpending.setAttribute("mid", $chobj.midmanne_id);
    divpending.classList = "mm-pending";
    el_ch.prepend(divpending);
    
    var toprow = document.createElement("div");
    toprow.classList = "idholder";
    divpending.appendChild(toprow);

        var spid = document.createElement("span");
        spid.classList="mm-id";
        spid.innerHTML = "<span class='lbl-white'>midmanne_id</span>"+$chobj.midmanne_id;
        toprow.appendChild(spid);

        var spnid = document.createElement("span");
        spnid.classList="mm-nid";
        spnid.innerHTML = "<span class='lbl-white'>nid</span>"+$chobj.midmanne_nid;
        toprow.appendChild(spnid);

    var spsocials = document.createElement("span");
    spsocials.classList="mm-socials";
    spsocials.innerHTML =  $chobj.midmanne_socials_desc;
    divpending.appendChild(spsocials);

    var adminactions = document.createElement("div");
    divpending.appendChild(adminactions);
    adminactions.classList = "mm-adminactions";
    adminactions.id="aa_"+$chobj.midmanne_id;
    
    var approve = document.createElement("span");
    approve.classList="action-approve";
    approve.innerHTML="approve";
    approve.style="margin-left:4px;";
    approve.title="click to approve!";
    adminactions.appendChild(approve);
    approve.addEventListener("click", (e)=>{
        var mid = ANNE.A.extractNearest(e.target, "mid");
        if (mid==null) {
            alert("problem.");
            return;
        }
        MIDMANNAGE.activateMM(MIDMANNAGE.defaultTargetNodeNid, mid, "APPROVE");
    });

    var decline = document.createElement("span");
    decline.classList="action-decline";
    decline.innerHTML="decline";
    decline.style="margin-left:60px;";
    decline.title="click to decline!";
    adminactions.appendChild(decline);
    decline.addEventListener("click", (e)=>{
        var mid = ANNE.A.extractNearest(e.target, "mid");
        if (mid==null) {
            alert("problem.");
            return;
        }
        MIDMANNAGE.activateMM(MIDMANNAGE.defaultTargetNodeNid, mid, "DECLINE");
    });
}
    


/**
 * We want the history, with a filter (preserve data/bandwidth/waste)
 * This also needs to be ENCRYPTED TO US.
 * We will decrypt on this side.
 * @param {*} $targetNodeNid 
 * @returns 
 */
MIDMANNAGE.getPendings=async($targetNodeNid="")=>{
    console.log("getPendings");
    ANNE.A.addClass("refresh_pending_inner", "spinnerself");
    await MIDMANNAGE.reconnectSocket();
    if ($targetNodeNid==undefined || $targetNodeNid==null || $targetNodeNid=="") {
        $targetNodeNid=MIDMANNAGE.defaultTargetNodeNid;
    }
    var adpayload = {
        adid:ANNE.UTILS.randHex(12),
        targetNodeNid:$targetNodeNid,
        user_nid:ANNE.USER._userNObj.nid,
        zpropagate:false,
        zreq_sig:true,
        zzzzret_targetNodeNid:ANNE._annodesLS.last_nid,
        zzzzz_encrypt_return:true
    }

    var pObj = await ANNE.ALTDATA.signMsg(adpayload);   //this will inject pubkey.
    if (pObj==null) {
        console.warn("signing problem");
        return null;
    }
    var adtype = "ADF_SWAP";
    var adsubtype = "ADMIN_PENDING_MM";
    var rez = await ANNE.API.sendAltData(adtype, adsubtype, pObj.payloadstring, pObj.sig);
    return rez;
}


/**
 * 
 * @param {*} $targetNodeNid 
 * @param {*} $midmanne_id 
 * @param {*} $response 
 * @returns 
 */
MIDMANNAGE.activateMM=async($targetNodeNid="", $midmanne_id, $answer="DECLINED")=>{
    await MIDMANNAGE.reconnectSocket();
    ANNE.A.spinnerInject("admin_spinner_"+$midmanne_id);

    if ($targetNodeNid==undefined || $targetNodeNid==null || $targetNodeNid=="") {
        $targetNodeNid=MIDMANNAGE.defaultTargetNodeNid;
    }
    var adpayload = {
        adid:ANNE.UTILS.randHex(12),
        answer:$answer,
        midmanne_id:$midmanne_id,
        targetNodeNid:$targetNodeNid,
        user_nid:ANNE.USER._userNObj.nid,
        zpropagate:false,
        zreq_sig:true,
        zzzzret_targetNodeNid:ANNE._annodesLS.last_nid,
        zzzzz_encrypt_return:true
    }

    var pObj = await ANNE.ALTDATA.signMsg(adpayload);   //this will inject pubkey.
    if (pObj==null) {
        console.warn("signing problem");
        return null;
    }

    var adtype = "ADF_SWAP";
    var adsubtype = "ADMIN_ACTIVATE_MM";
    var rez = await ANNE.API.sendAltData(adtype, adsubtype, pObj.payloadstring, pObj.sig);
    return rez;
}
